// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas;

/**
  * This interface must be implemented by applets and frames that wish to
  * read the contents of a serialization file. When reading a serialization
  * file ObjectInputStream will walk up the call stack and find the first
  * ClassLoader in effect. If this ClassLoader is not the same as the one used
  * by the applet problems may arise. Specifically if a set of classes are
  * installed on the local client (such as webAF.jar) and the loading
  * class is loaded from the client (com.sas.ObjectLoaderThread) then reading
  * the serialization file will result in loading only classes from the client as
  * well.
  *
  * @author saskmo (Karl Moss)
  * @date   29Jun1988
  */

public interface ObjectLoaderInterface
{
  /**
    * Read the contents of the given serialization file.
    *
    * @param in ObjectInputStream to read the serialization file with
    * @return A Hashtable containing all of the serialized components
    */
  java.util.Hashtable readObjects(java.io.ObjectInputStream in)
    throws Exception;
}
