// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas;

import java.lang.Cloneable;

/**
 * A public interface for objects which may be cloned.
 * This allows objects which are typed by interfaces
 * instead of concrete/abstract classes to be cloned.
 *
 * @author sasdjb <A HREF="http://www.unx.sas.com/~sasdjb/Home.html">David J. Biesack</A>
 * @history 
 * <dl>
 * <dt>Wed Sep 11 1996  <dd>Created
 * </dl>
 */

public interface PublicClonable extends Cloneable
{
  /**
   * Clone an object.
   * @return a clone of the object.
   * @exception java.lang.CloneNotSupportedException
   *            if the clone fails. 
   */
  Object clone() throws CloneNotSupportedException;
}
