// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.beans;

/**
 * CustomizerClosingInterface should be implemented by those
 * customizers used in webAF which need to be notified before
 * they are closed.
 * This is typically useful when a Customizer sets up a link
 * or an event handler on the object being customized, since 
 * the handler or link should be removed before the customizer
 * is closed.
 */
public interface CustomizerClosingInterface
{
	/**
	 * customizerClosing is called when the Customizer
	 * is about to be closed and any resources it uses or
	 * attachments it has to the object being customized
	 * should be released/removed.
	 */
	public void customizerClosing();
}
