// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.beans;

/**
 * ExtendedPropertyEditorInterface is an extension of the
 * <code>java.beans.PropertyEditor</code> class.  It provides 
 * an additional method (isEditable) which allows non-editable
 * properties to show up in the webAF property sheet.
 */
public interface ExtendedPropertyEditorInterface extends java.beans.PropertyEditor
{
	/**
	 * isEdittable() should return true if the property value is editable
	 * when getAsText() returns non-null.  If it is not true, the property
	 * sheet displaying the property value should not allow if to be edited.
	 * <P>
	 * Note that this method should always return the same value for a given
	 * instance of the PropertyEditor implementing it.  This is so that the 
	 * user does not have to constantly check for changes in the edit status.
	 * <P>
	 * Since this method will not be called by other property sheets other
	 * than the SAS property sheet, the setAsText() method of the PropertyEditor
	 * interface must throw an exception right away if isEditable() returns
	 * false.
	 */
	public boolean isEditable();
}