// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.collection;
import com.sas.collection.ContentsChangedEvent;

/**
 * An interface for objects which listen for ContentsChangedEvent events.
 * A ContentsChangedListener listens for and responds to ContentsChangedEvent events
 * from a ContentsChangedSource (an object such as a collection that fires
 * ContentsChangedEvent when its contents change).
 * @author sasdjb <A HREF="http://www.unx.sas.com/~sasdjb/Home.html">David J. Biesack</A>
 * @see com.sas.collection.ContentsChangedSource
 * @see com.sas.collection.ContentsChangedEvent
 */

public interface ContentsChangedListener
       extends java.util.EventListener
{
  /**
   * Handle a ContentsChangedEvent.
   * @param event the change event describing how the
   *        contents of the source object have changed.
   */
  void contentsChanged(ContentsChangedEvent event);
}
