// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
package com.sas.iom;

import com.sas.util.UncheckedException;
//
// History Records:
//
// Date    Name            Remarks
// 17Jun99 M Srinivasan    Created.
// 23Jul00 B Beers         S0090931 Integrate WorkspacePoolDriver and WorkspaceFactory.
// 09Apr02 B Beers         S0141718: Remove dependencies on netutil.jar.
//
/**
 * The exception class for the WorkspaceFactory. Sometimes this class is
 * merely a wrapper for an exception throw from deep within the factory.
 * @author Murali Srinivasan
 * @author Biff Beers
 */
public class WorkspaceFactoryException extends UncheckedException
{
     /**
      * No-argument constructor.
      */
     public WorkspaceFactoryException()
     {
         super();
     }

     /**
      * Constructor with message.
      * @param message a message adding detail to the exception
      */
     public WorkspaceFactoryException(java.lang.String message)
     {
         super(message);
     }

     /**
      * Wrapper constructor.
      * @param nestedException exception being wrapped
      */
     public WorkspaceFactoryException(java.lang.Throwable nestedException)
     {
          super(nestedException,null);
     }

     /**
      * Wrapper constructor.
      * @param message a message to include in the exception.
      * @param nestedException an exception being wrapped.
      */
     public WorkspaceFactoryException(String message,java.lang.Throwable nestedException)
     {
          super(nestedException,message);
     }
}