// Copyright (c) 2000 by SAS Institute Inc., Cary, NC 27513
package com.sas.iom;

import java.io.Serializable;
//
// History:
//
// Date    Name            Remarks
// 23Jul00 B Beers         S0090931: Integrate WorkspacePoolDriver and WorkspaceFactory.
// 24Jan01 B Beers         S0107599: Add equals method.
// 03Sep02 B Beers         S0164497: Reimplement over com.sas.services.connection.
//
/**
 * @author Biff Beers
 */
public class WorkspacePoolCookie implements Serializable
{
     protected WorkspacePoolCookie(int cxfConfigHashCode)
     {
          this.serialNumber = serialNumberCounter++;
          this.cxfConfigHashCode = cxfConfigHashCode;
     }
     
	public boolean equals(Object that)
     {
          if (this == that)
          {
               return true;
          }

          if (that == null || !that.getClass().getName().equals(getClass().getName()))
          {
               return false;
          }

          WorkspacePoolCookie thatCookie = (WorkspacePoolCookie)that;
          long thatSerialNumber = thatCookie.getSerialNumber();

          if (serialNumber != thatSerialNumber)
          {
               return false;
          }

          int thatCxfConfigHashCode = thatCookie.getCxfConfigHashCode();

          if (cxfConfigHashCode != thatCxfConfigHashCode)
          {
               return false;
          }

          return true;
     }

     public int hashCode()
     {
          int hc = getClass().getName().hashCode();
          hc ^= (int)(serialNumber & 0xFFFFFFFF);
          hc ^= (int)((serialNumber >>> 32) & 0xFFFFFFFF);
          hc ^= cxfConfigHashCode;
          return hc;
     }

     static final long serialVersionUID = 3892061344346582248L;
     private static long serialNumberCounter = Long.MIN_VALUE;
     private long serialNumber = 0;
     private int cxfConfigHashCode = 0;

     protected long getSerialNumber()
     {
          return serialNumber;
     }

     protected int getCxfConfigHashCode()
     {
          return cxfConfigHashCode;
     }
}