// Copyright (c) 1999 by SAS Institute Inc., Cary, NC 27513
package com.sas.iom;

import com.sas.util.ChainedException;
//
// History:
//
// Date    Name            Remarks
// 24Nov99 B Beers         Created.
// 23Jul00 B Beers         S0090931: Integrate WorkspacePoolDriver and WorkspaceFactory.
// 25Jan01 B Beers         S0108231: Added doc comment and deprecation tag.
// 09Apr02 B Beers         S0141718: Remove dependencies on netutil.jar.
//
/**
 * The exception class for the deprecated class WorkspacePoolDriver.
 * @deprecated WorkspacePoolDriver and WorkspacePoolException have
 * been deprecated in favor of the less ambiguous WorkspaceFactory
 * and WorkspaceFactoryException.
 * @author Biff Beers
 * @see com.sas.iom.WorkspaceFactoryException
 */
public class WorkspacePoolException extends ChainedException
{
     // constructors
     //---------------------------------------------------------
     /**
      * No-argument constructor.
      */
     public WorkspacePoolException()
     {
          super();
     }

     /**
      * Constructor with message.
      * @param message a message adding detail to the exception
      */
     public WorkspacePoolException(String message)
     {
          super(message);
     }

     /**
      * Wrapper constructor.
      * @param nestedException exception being wrapped
      */
     public WorkspacePoolException(Throwable nestedException)
     {
          super(nestedException,null);
     }

     /**
      * Wrapper constructor.
      * @param message a message to include in the exception.
      * @param nestedException an exception being wrapped.
      */
     public WorkspacePoolException(String message,Throwable nestedException)
     {
          super(nestedException,message);
     }
}