// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold booleans
 * that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Dec 11 1996  <dd>Created
 * </dl>
 */


public interface BooleanDataInterface
{

        /**
         * Retrieve the boolean stored in the boolean model
         * @return  boolean value
         */
        public boolean getBooleanData();

        /**
         * Sets the boolean stored in the boolean model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setBooleanData() may
         * or may not imply that a subsequent call to
         * getBooleanData() will return the information that
         * was sent to setBooleanData()
         */
        public void setBooleanData(boolean value);
}
