// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold bytes 
 * that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Jan 31 1997  <dd>Created
 * </dl>
 */


public interface ByteDataInterface
{

        /**
         * Retrieve the byte stored in the byte model
         * @return  byte value
         */
        public byte getByteData();

        /**
         * Sets the byte stored in the byte model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setByteData() may
         * or may not imply that a subsequent call to
         * getByteData() will return the information that
         * was sent to setByteData()
         */
        public void setByteData(byte value);
}
