// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold chars 
 * that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Jan 31 1997  <dd>Created
 * </dl>
 */


public interface CharacterDataInterface
{

        /**
         * Retrieve the char stored in the char model
         * @return  char value
         */
        public char getCharacterData();

        /**
         * Sets the char stored in the char model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setCharacterData() may
         * or may not imply that a subsequent call to
         * getCharacterData() will return the information that
         * was sent to setCharacterData()
         */
        public void setCharacterData(char value);
}
