// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold doubles 
 * that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Jan 31 1997  <dd>Created
 * </dl>
 */


public interface DoubleDataInterface
{

        /**
         * Retrieve the double stored in the double model
         * @return  double value
         */
        public double getDoubleData();

        /**
         * Sets the double stored in the double model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setDoubleData() may
         * or may not imply that a subsequent call to
         * getDoubleData() will return the information that
         * was sent to setDoubleData()
         */
        public void setDoubleData(double value);
}
