// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold floats 
 * that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Jan 31 1997  <dd>Created
 * </dl>
 */


public interface FloatDataInterface
{

        /**
         * Retrieve the float stored in the float model
         * @return  float value
         */
        public float getFloatData();

        /**
         * Sets the float stored in the float model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setFloatData() may
         * or may not imply that a subsequent call to
         * getFloatData() will return the information that
         * was sent to setFloatData()
         */
        public void setFloatData(float value);
}
