// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold ints 
 * that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Jan 31 1997  <dd>Created
 * </dl>
 */


public interface IntegerDataInterface
{

        /**
         * Retrieve the int stored in the int model
         * @return  int value
         */
        public int getIntegerData();

        /**
         * Sets the int stored in the int model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setIntegerData() may
         * or may not imply that a subsequent call to
         * getIntegerData() will return the information that
         * was sent to setIntegerData()
         */
        public void setIntegerData(int value);
}
