// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold long integers that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Jan 31 1997  <dd>Created
 * </dl>
 */


public interface LongDataInterface
{

        /**
         * Retrieve the long stored in the long model
         * @return  long value
         */
        public long getLongData();

        /**
         * Sets the long stored in the long model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setLongData() may
         * or may not imply that a subsequent call to
         * getLongData() will return the information that
         * was sent to setLongData()
         */
        public void setLongData(long value);
}
