// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold Objects 
 * that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Jan 31 1997  <dd>Created
 * </dl>
 */


public interface ObjectDataInterface
{

        /**
         * Retrieve the Object stored in the Object model
         * @return  Object value
         */
        public Object getObjectData();

        /**
         * Sets the Object stored in the Object model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setObjectData() may
         * or may not imply that a subsequent call to
         * getObjectData() will return the information that
         * was sent to setObjectData()
         */
        public void setObjectData(Object value);
}
