// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.lang;


/**
 * An interface for things that hold shorts
 * that can be queried by outsiders.
 * @author Jennifer Appetta
 * @version 1.0
 * @history
 * <dl>
 * <dt>Jan 31 1997 
 * <dd>Created
 * </dl>
 */


public interface ShortDataInterface
{

        /**
         * Retrieve the short stored in the short model
         * @return  short value
         */
        public short getShortData();

        /**
         * Sets the short stored in the short model.  The
         * implementation will decide how to synthesize
         * this information.  A call to setShortData() may
         * or may not imply that a subsequent call to
         * getShortData() will return the information that
         * was sent to setShortData()
         */
        public void setShortData(short value);
}
