/* $Id$ */
package com.sas.net.brg;

import java.util.Properties;
import java.util.logging.Logger;

import org.omg.CORBA.Any;
import org.omg.CORBA.NVList;
import org.omg.CORBA.StringHolder;
//
// History:
//
// Date    Name            Remarks
// 23Aug01 B Beers         S0124519: Split socket driver code into SocketAccessMethod.
// 12Oct01 B Beers         S0129352: Remove connection sharing logic.
// 14Feb02 B Beers         S0139873: Added User Service authorization.
// 19Nov02 B Beers         S0169574: Revise password generation support.
// 11Jul03 B Beers         S0211000: Remove thread create from DelegateImpl.finalize().
// 12Nov03 B Beers         S0227109: Remove stub finalizers.
// 16Dec03 B Beers         S0227513: Log unhandled exceptions.
// 29Jan04 B Beers         S0233579: Use logger associated with user that created factory.
/**
 * @author Biff Beers
 */
public interface AccessMethodInterface
{
     public abstract Properties getProperties();
     public abstract Logger getLogger();
     public abstract void setLogger(Logger logger);
     public abstract void setProtocolEngine(BridgeProtocolEngine engine);
     public abstract int connect();
     public abstract boolean isConnected();
     public abstract int newObject(String classID);
     public abstract boolean interfaceInObject(int objectID,String interfaceID);
     public abstract String[] eventsFromObjectID(int objectID);
     public abstract void advise(int objectID,String eventInterfaceID);
     public abstract void unadvise(int objectID,String eventInterfaceID);
     public abstract void generatePassword(String userName,StringHolder qualUserNameHolder,StringHolder genPasswordHolder);
     public abstract void sendRequest(int objectID,String interfaceID,String name,NVList parameters,Any result);
     public abstract void sendEvent(int objectID,String interfaceID,NVList parameters);
     public abstract void sendReply(int objectID,String interfaceID,String name,int replyID,NVList parameters,Any result);
     public abstract void sendSystemError(int objectID,String interfaceID,int replyID,Throwable ex);
     public abstract void sendUserError(int objectID,String interfaceID,int replyID,Any ex);
     public abstract void reconcileParameters(ParameterHandleInterface parmHandle,NVList parameters);
     public abstract void releaseParameters(ParameterHandleInterface parmHandle);
     public abstract void close();
}