// Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513
package com.sas.net.brg.orb;
//
// History:
//
// Date    Name            Remarks
// 28Feb01 B Beers         S0110393: Add bind and server flow features.
//
/**
 * @author Biff Beers
 */
public class ActiveObjectMapKey
{
     public void setValue(byte[] value)
     {
          this.value = value;
     }

     public byte[] getValue()
     {
          return value;
     }

     public boolean equals(Object that)
     {
          if (that == null || !(that instanceof ActiveObjectMapKey))
          {
               return false;
          }

          byte[] thatValue = ((ActiveObjectMapKey)that).getValue();
          byte[] thisValue = value;

          if (thisValue == thatValue)
          {
               return true;
          }

          if (thisValue == null || thatValue == null)
          {
               return false;
          }

          final int thisLength = thisValue.length;

          if (thisLength != thatValue.length)
          {
               return false;
          }

          for (int i=0;i<thisLength;i++)
          {
               if (thisValue[i] != thatValue[i])
               {
                    return false;
               }
          }

          return true;
     }

     public int hashCode()
     {
          if (value == null)
          {
               return 0;
          }

          int code = 0;
          int i = 0;

          for (;i<value.length;i+=4)
          {
               for (int j=0;j<4&&i+j<value.length;j++)
               {
                    int x = value[i+j];
                    x <<= (j*8);
                    code ^= x;
               }
          }

          return code;
     }

     private byte[] value = null;
}