// Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513
package com.sas.net.brg.orb;

import org.omg.CORBA.BAD_INV_ORDER;
import org.omg.CORBA_2_3.portable.ObjectImpl;
import org.omg.PortableServer.Servant;
//
// History:
//
// Date    Name            Remarks
// 28Feb01 B Beers         S0110393: Add bind and server flow features.
// 02May01 B Beers         S0115600: Allow client operation without orb.jar.
//
/**
 * @author Biff Beers
 */
public class GenericObject extends ObjectImpl
{
     public String[] _ids()
     {
          try
          {
               DelegateBase delegate = (DelegateBase)_get_delegate();
               Servant servant = (Servant)delegate.getServant();

               if (servant != null)
               {
                    return servant._all_interfaces(null,null);
               }
          }
          catch (BAD_INV_ORDER e)
          {
          }

          return __ids;
     }

     private static final String[] __ids = {"IDL:omg.org/CORBA/Object:1.0"};
}