// Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513
package com.sas.net.brg.orb;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import org.omg.CORBA.BAD_PARAM;
import org.omg.CORBA.Policy;
import org.omg.CORBA.portable.Delegate;
import org.omg.CORBA_2_3.portable.ObjectImpl;
import org.omg.PortableServer.AdapterActivator;
import org.omg.PortableServer.DynamicImplementation;
import org.omg.PortableServer.IdAssignmentPolicy;
import org.omg.PortableServer.IdAssignmentPolicyValue;
import org.omg.PortableServer.IdUniquenessPolicy;
import org.omg.PortableServer.IdUniquenessPolicyValue;
import org.omg.PortableServer.ImplicitActivationPolicy;
import org.omg.PortableServer.ImplicitActivationPolicyValue;
import org.omg.PortableServer.LifespanPolicy;
import org.omg.PortableServer.LifespanPolicyValue;
import org.omg.PortableServer.POA;
import org.omg.PortableServer.POAManager;
import org.omg.PortableServer.RequestProcessingPolicy;
import org.omg.PortableServer.RequestProcessingPolicyValue;
import org.omg.PortableServer.Servant;
import org.omg.PortableServer.ServantManager;
import org.omg.PortableServer.ServantRetentionPolicy;
import org.omg.PortableServer.ServantRetentionPolicyValue;
import org.omg.PortableServer.ThreadPolicy;
import org.omg.PortableServer.ThreadPolicyValue;
import org.omg.PortableServer.POAPackage.AdapterAlreadyExists;
import org.omg.PortableServer.POAPackage.AdapterNonExistent;
import org.omg.PortableServer.POAPackage.InvalidPolicy;
import org.omg.PortableServer.POAPackage.NoServant;
import org.omg.PortableServer.POAPackage.ObjectAlreadyActive;
import org.omg.PortableServer.POAPackage.ObjectNotActive;
import org.omg.PortableServer.POAPackage.ServantAlreadyActive;
import org.omg.PortableServer.POAPackage.ServantNotActive;
import org.omg.PortableServer.POAPackage.WrongAdapter;
import org.omg.PortableServer.POAPackage.WrongPolicy;
import com.sas.lang.RunnableQueue;
import com.sas.text.Message;
//
// History:
//
// Date    Name            Remarks
// 28Feb01 B Beers         S0110393: Add bind and server flow features.
// 02May01 B Beers         S0115600: Allow client operation without orb.jar.
// 10Apr02 B Beers         S0141718: Remove dependency on netutil.jar.
// 16Oct02 B Beers         S0165908: Remove org.omg.PortableServer package.
//
/**
 * @author Biff Beers
 */
public class POAImpl extends ObjectImpl implements POA
{
     protected POAImpl(BrgOrb orb,String name,Policy[] policies,Map activeObjectMap)
     {
          this.orb = orb;
          this.name = name;

          if (activeObjectMap == null)
          {
               this.activeObjectMap = new HashMap();
          }
          else
          {
               this.activeObjectMap = activeObjectMap;
          }

          servantDelegate = new ServantDelegateImpl(orb,this);
     }

     public POA create_POA(String adapter_name,POAManager a_POAManager,Policy[] policies) throws AdapterAlreadyExists,InvalidPolicy
     {
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public POA find_POA(String adapter_name,boolean activate_it) throws AdapterNonExistent
     {
          throw new AdapterNonExistent(adapter_name);
     }

     public void destroy(boolean etherealize_objects, boolean wait_for_completion)
     {
     }

     public ThreadPolicy create_thread_policy(ThreadPolicyValue value)
     {
          // default is ORB_CONTROL_MODEL
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public LifespanPolicy create_lifespan_policy(LifespanPolicyValue value)
     {
          // default is TRANSIENT
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public IdUniquenessPolicy create_id_uniqueness_policy(IdUniquenessPolicyValue value)
     {
          // default is UNIQUE_ID
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public IdAssignmentPolicy create_id_assignment_policy(IdAssignmentPolicyValue value)
     {
          // default is USER_ID
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public ImplicitActivationPolicy create_implicit_activation_policy(ImplicitActivationPolicyValue value)
     {
          // default is NO_IMPLICIT_ACTIVATION
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public ServantRetentionPolicy create_servant_retention_policy(ServantRetentionPolicyValue value)
     {
          // default is RETAIN
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public RequestProcessingPolicy create_request_processing_policy(RequestProcessingPolicyValue value)
     {
          // default is USE_SERVANT_MANAGER
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public String the_name()
     {
          return name;
     }

     public POA the_parent()
     {
          return null;
     }

     public POA[] the_children()
     {
          return new POA[0];
     }

     public POAManager the_POAManager()
     {
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public AdapterActivator the_activator()
     {
          return activator;
     }

     public void the_activator(AdapterActivator the_activator)
     {
          activator = the_activator;
     }

     public ServantManager get_servant_manager() throws WrongPolicy
     {
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public void set_servant_manager(ServantManager imgr) throws WrongPolicy
     {
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public Servant get_servant() throws NoServant,WrongPolicy
     {
          throw new WrongPolicy();
     }

     public void set_servant(Servant p_servant) throws WrongPolicy
     {
          throw new WrongPolicy();
     }

     public byte[] activate_object(Servant p_servant) throws ServantAlreadyActive,WrongPolicy
     {
          throw new WrongPolicy();
     }

     public void activate_object_with_id(byte[] id,Servant p_servant) throws ServantAlreadyActive,ObjectAlreadyActive,WrongPolicy
     {
          if (id == null)
          {
               // {0}: An object ID may not be null.
               String messageIndex = "orb.O100.ex.msg";
               String messagePattern = RB.getStringResource(messageIndex);
               String message = Message.format(messagePattern,messageIndex);
               throw new BAD_PARAM(message);
          }

          if (p_servant == null)
          {
               // {0}: A servant may not be null.
               String messageIndex = "orb.O101.ex.msg";
               String messagePattern = RB.getStringResource(messageIndex);
               String message = Message.format(messagePattern,messageIndex);
               throw new BAD_PARAM(message);
          }

          if (!(p_servant instanceof DynamicImplementation))
          {
               // {0}: A servant for {1} must extend {2}.
               String messageIndex = "orb.O102.ex.msg";
               String messagePattern = RB.getStringResource(messageIndex);
               String message = Message.format(messagePattern,messageIndex,orb.getClass().getName(),DynamicImplementation.class.getName());
               throw new BAD_PARAM(message);
          }

          synchronized (activeObjectMap)
          {
               if (activeObjectMap.containsKey(id))
               {
                    throw new ObjectAlreadyActive();
               }

               Set references = activeObjectMap.entrySet();
               Iterator referenceIterator = references.iterator();

               while (referenceIterator.hasNext())
               {
                    ObjectImpl reference = (ObjectImpl)((Map.Entry)referenceIterator.next()).getValue();
                    DelegateBase delegate = (DelegateBase)reference._get_delegate();
                    Servant servant = (Servant)delegate.getServant();

                    if (p_servant.equals(servant))
                    {
                         throw new ServantAlreadyActive();
                    }
               }

               p_servant._set_delegate(servantDelegate);
               GenericObject reference = orb.getGenericObject();
               DelegateBase referenceDelegate = orb.getDelegateBase();
               referenceDelegate.setObjectID(id);
               referenceDelegate.setServant((DynamicImplementation)p_servant);
               referenceDelegate.setWrapper(reference);
               referenceDelegate.setQueue(new RunnableQueue("dispatch thread",1));
               reference._set_delegate(referenceDelegate);
               ActiveObjectMapKey key = orb.getActiveObjectMapKey();
               key.setValue(id);
               activeObjectMap.put(key,reference);
          }
     }

     public void deactivate_object(byte[] oid) throws ObjectNotActive,WrongPolicy
     {
          deactivate_object_impl(oid,false);
     }

     private void deactivate_object_impl(byte[] oid,boolean waitForCompletion) throws ObjectNotActive,WrongPolicy
     {
          if (oid == null)
          {
               // {0}: An object ID may not be null.
               String messageIndex = "orb.O103.ex.msg";
               String messagePattern = RB.getStringResource(messageIndex);
               String message = Message.format(messagePattern,messageIndex);
               throw new BAD_PARAM(message);
          }

          synchronized (activeObjectMap)
          {
               ActiveObjectMapKey key = orb.getActiveObjectMapKey();
               key.setValue(oid);
               ObjectImpl reference = (ObjectImpl)activeObjectMap.remove(key);
               orb.returnActiveObjectMapKey(key);

               if (reference == null)
               {
                    throw new ObjectNotActive();
               }

               DelegateBase referenceDelegate = (DelegateBase)reference._get_delegate();
               RunnableQueue queue = referenceDelegate.getQueue();
               queue.shutDown(waitForCompletion,true);
               orb.returnActiveObjectMapKey(referenceDelegate.getActiveObjectMapKey());
               orb.returnDelegateBase(referenceDelegate);
          }
     }

     public org.omg.CORBA.Object create_reference(java.lang.String intf) throws WrongPolicy
     {
          throw new WrongPolicy();
     }

     public org.omg.CORBA.Object create_reference_with_id(byte[] oid,String intf)
     {
          throw new org.omg.CORBA.NO_IMPLEMENT();
     }

     public byte[] servant_to_id(Servant p_servant) throws ServantNotActive,WrongPolicy
     {
          synchronized (activeObjectMap)
          {
               Set references = activeObjectMap.entrySet();
               Iterator referenceIterator = references.iterator();

               while (referenceIterator.hasNext())
               {
                    ObjectImpl reference = (ObjectImpl)((Map.Entry)referenceIterator.next()).getValue();
                    DelegateBase referenceDelegate = (DelegateBase)reference._get_delegate();
                    Servant servant = (Servant)referenceDelegate.getServant();

                    if (p_servant.equals(servant))
                    {
                         return referenceDelegate.getObjectID();
                    }
               }

               throw new ServantNotActive();
          }
     }

     public org.omg.CORBA.Object servant_to_reference(Servant p_servant) throws ServantNotActive,WrongPolicy
     {
          synchronized (activeObjectMap)
          {
               Set references = activeObjectMap.entrySet();
               Iterator referenceIterator = references.iterator();

               while (referenceIterator.hasNext())
               {
                    ObjectImpl reference = (ObjectImpl)((Map.Entry)referenceIterator.next()).getValue();
                    DelegateBase referenceDelegate = (DelegateBase)reference._get_delegate();
                    Servant servant = (Servant)referenceDelegate.getServant();

                    if (p_servant.equals(servant))
                    {
                         return reference;
                    }
               }

               throw new ServantNotActive();
          }
     }

     public Servant reference_to_servant(org.omg.CORBA.Object reference) throws ObjectNotActive,WrongPolicy
     {
          Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl)reference)._get_delegate();

          if (!(delegate instanceof DelegateBase))
          {
               throw new ObjectNotActive();
          }

          Servant servant = (Servant)((DelegateBase)delegate).getServant();

          if (servant == null)
          {
               throw new ObjectNotActive();
          }

          return servant;
     }

     public byte[] reference_to_id(org.omg.CORBA.Object reference) throws WrongAdapter,WrongPolicy
     {
          Delegate delegate = ((org.omg.CORBA.portable.ObjectImpl)reference)._get_delegate();

          if (!(delegate instanceof DelegateBase))
          {
               throw new WrongAdapter();
          }

          byte[] objectID = ((DelegateBase)delegate).getObjectID();

          if (objectID == null)
          {
               throw new WrongAdapter();
          }

          return objectID;
     }

     public Servant id_to_servant(byte[] oid) throws ObjectNotActive,WrongPolicy
     {
          synchronized (activeObjectMap)
          {
               ActiveObjectMapKey key = orb.getActiveObjectMapKey();
               key.setValue(oid);
               ObjectImpl reference = (ObjectImpl)activeObjectMap.get(key);
               orb.returnActiveObjectMapKey(key);

               if (reference == null)
               {
                    throw new ObjectNotActive();
               }

               DelegateBase referenceDelegate = (DelegateBase)reference._get_delegate();
               return (Servant)referenceDelegate.getServant();
          }
     }

     public org.omg.CORBA.Object id_to_reference(byte[] oid) throws ObjectNotActive,WrongPolicy
     {
          synchronized (activeObjectMap)
          {
               ActiveObjectMapKey key = orb.getActiveObjectMapKey();
               key.setValue(oid);
               ObjectImpl reference = (ObjectImpl)activeObjectMap.get(key);
               orb.returnActiveObjectMapKey(key);

               if (reference == null)
               {
                    throw new ObjectNotActive();
               }

               return reference;
          }
     }

     public synchronized String[] _ids()
     {
          if (ids == null)
          {
               ids = new String[1];
               ids[0] = "IDL:PortableServer/POA:1.0";
          }

          return ids;
     }

     public byte[] id()
     {
          int hc = hashCode();
          byte[] id = new byte[4];

          for (int i=0;i<4;i++)
          {
               id[i] = (byte)((hc >>> (i * 8)) & 0xFF);
          }

          return id;
     }

     private BrgOrb orb = null;
     private String name = null;
     private AdapterActivator activator = null;
     private Map activeObjectMap = null;
     private ServantDelegateImpl servantDelegate = null;
     private String[] ids = null;

     protected void close(boolean waitForCompletion)
     {
          synchronized (activeObjectMap)
          {
               Set oidSet = activeObjectMap.keySet();
               Iterator oidIterator = oidSet.iterator();

               while (oidIterator.hasNext())
               {
                    byte[] oid = (byte[])oidIterator.next();

                    try
                    {
                         deactivate_object_impl(oid,waitForCompletion);
                    }
                    catch (Exception e)
                    {
                    }
               }
          }
     }
}