// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.net.crypto;

import java.io.PrintStream;
import java.io.PrintWriter;
import com.sas.net.util.WrapperException;

//
// History:
//
// Date    Name            Remarks
// 24Jun98 Biff Beers      Created.
// 10Sep98 Biff Beers      Added nested exception support.
// 24May99 Biff Beers      S0054825 Started using WrapperException base class.
//
/**
 * This class is the common exception class thrown by all the
 * various cryptography implementations.
 * @author Biff Beers
 */
public class CryptoException extends WrapperException
{
     // constructors
     //---------------------------------------------------------
     /**
      * The no-argument constructor.
      */
     public CryptoException()
     {
          super();
     }

     /**
      * This constructor needs a detailed message.
      * @param msg a detailed message.
      */
     public CryptoException(String msg)
     {
          super(msg);
     }

     /**
      * This constructor needs a nested exception.
      * @param t a nested exception
      */
     public CryptoException(Throwable t)
     {
          super(t);
     }

     /**
      * Wrapper constructor.
      * @param msg a message to include in the exception.
      * @param t an exception being wrapped.
      */
     public CryptoException(String msg,Throwable t)
     {
          super(msg,t);
     }
}