/* $Id$ */
/* Copyright (c)1998 SAS Institute Inc, Cary NC USA 27513
 * Unpublished- All Rights Reserved.
 */

package com.sas.rio;

import java.io.IOException;
import java.sql.DatabaseMetaData;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Statement;
import java.sql.Types;
import java.util.Properties;

import org.omg.CORBA.ShortHolder;
import org.omg.CORBA.IntHolder;
import org.omg.CORBA.StringHolder;
import com.sas.iom.SAS.IDBMSConnection;
import com.sas.iom.SAS.IDataSet;
import com.sas.iom.SAS.IWorkspace;
import com.sas.iom.SAS.IDataService;
import com.sas.iom.SAS.IUtilities;
import com.sas.iom.SAS.IHostSystem;
import com.sas.iom.SAS.IDataSetPackage.BindKeys;
import com.sas.iom.SASIOMDefs.StringSeqHolder;
import com.sas.iom.SASIOMDefs.VariableArray2dOfStringHolder;
// 14Jan2005   damack  S0278967: added ctor taking a properties object so that we can pass 
//                               coercenumerictypes properly
/**
 * This class provides information about the database as a whole.
 *
 * <P>Many of the methods here return lists of information in ResultSets.
 * You can use the normal ResultSet methods such as getString and getInt
 * to retrieve the data from these ResultSets.  If a given form of
 * metadata is not available, these methods should throw a SQLException.
 *
 * <P>Some of these methods take arguments that are String patterns.  These
 * arguments all have names such as fooPattern.  Within a pattern String, "%"
 * means match any substring of 0 or more characters, and "_" means match
 * any one character. Only metadata entries matching the search pattern
 * are returned. If a search pattern argument is set to a null ref, it means
 * that argument's criteria should be dropped from the search.
 *
 * <P>A SQLException will be thrown if a driver does not support a meta
 * data method.  In the case of methods that return a ResultSet,
 * either a ResultSet (which may be empty) is returned or a
 * SQLException is thrown.
 */
public class MVADatabaseMetaDatav82 extends MVADatabaseMetaData
{
    public MVADatabaseMetaDatav82(MVAConnection c) throws SQLException
    {
	super(c);
    }
    public MVADatabaseMetaDatav82(MVAConnection c, java.util.Properties p) throws SQLException
    {
	super(c, p);
    }

    public boolean supportsLikeEscapeClause()
    {
	/**
	 * for v8.2 (and after) SAS, we do support the like escape clause.
	 * see RIO C Server Connection doc.
	 */
	return true;
    }
}
