/* Copyright (c)1998 SAS Institute Inc, Cary NC USA 27513
 * Unpublished- All Rights Reserved.
 */
package com.sas.rio;

import java.lang.Exception;

/**
 * Exception class for proprietary extensions to the SAS IOM Driver for JDBC.
 */
public class RIOException extends Exception {
    private int code = 0;

    /**
     * Constructs a RIOException object.
     *
     * @param reason A description of the exception.
     * @param code A specific exception code.
     */
    public RIOException(int code, String reason) {
	super(reason);
	this.code = code;
    }

    /**
     * Constructs a RIOException object.
     *
     * @param reason A description of the exception.
     * @param code A specific exception code.
     */
    public RIOException(String reason) {
	super(reason);
	this.code = -1;
    }

    /**
     * Gets the exception code value.
     *
     * @return The RIOException's code value.
     */
    public int getErrorCode() {
	return (code);
    }

}


