package com.sas.rio;
/**
 * 04/21/2003 - damack S0195329: add a columntypes array parm to updaterow.
 * 05/06/2003 - damack S0196790: changed return type on readRecords to be "DataHolder"
 */
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.sql.SQLWarning;
public interface XUtil extends Remote
{
    public String getDBMSVersion() throws RemoteException;
    public int executeUpdate(String sql) throws RemoteException, SQLException;
    public int executeQuery(String sql, boolean randomAccess)
        throws RemoteException, SQLException;
    public void deleteTable(
        String libref,
        String tableName,
        String tableType,
        String alterPassword)
        throws RemoteException, SQLException;
    public boolean createTable(
        String libref,
        String tableName,
        Column[] columns,
        String options)
        throws RemoteException, SQLException;


    public DataHolder readRecords(
        int hashCode,
        int flags,
        int bindKey,
        int rows,
        int rowOffset,
        byte[] pos,
        int[] columnTypes)
        throws RemoteException, SQLException;
    /**
    public Object[][] readRecords(
        int hashCode,
        int flags,
        int bindKey,
        int rows,
        int rowOffset,
        byte[] pos,
        int[] columnTypes,
        java.util.ArrayList bookmarks)
        throws RemoteException, SQLException;
    */
    public boolean insertRow(int hashCode, Object[] data, int bindKey, int[] columnTypes)
        throws RemoteException, SQLException;
    public boolean updateRow(
        int hashCode,
        Object[] data,
        byte[] bookmark,
        int bindKey, int[] columnTypes) /** S0195329: add columntypes array */
        throws RemoteException, SQLException;
    public boolean deleteRow(int hashCode, byte[] bookmark)
        throws RemoteException, SQLException;
    public Object[][] getColumnInfo(int hashCode)
        throws RemoteException, SQLException;
    public int openDataSet(
        String libref,
        String tableName,
        String[] password,
        String options,
        int concurFlag,
        int typeFlag)
        throws RemoteException, SQLException;
    public boolean isConnected() throws RemoteException;
    public int getStatus() throws RemoteException;
    public SQLWarning getWarning() throws RemoteException;
    public void close(int hashCode) throws RemoteException;
    public void disconnect() throws RemoteException, SQLException;
    public int countRecords(int hashCode) throws RemoteException, SQLException;
    public void releaseLibref() throws RemoteException;
    /** S0181889 - add method to get the bookmark array */
    public byte[] getBookmarkArray() throws RemoteException;
}
