package com.sas.rio.rmi;

import java.rmi.Naming;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.server.UnicastRemoteObject;

import com.sas.iom.SAS.IDataService;
import com.sas.iom.SAS.IWorkspace;
import com.sas.rio.AppServer;
import com.sas.rio.XUtil;

public class AppServerImpl extends UnicastRemoteObject implements Remote, AppServer {
    private static String host = "mackie.us.sas.com";
    private static int port = 1099;
        
    public AppServerImpl(String args[]) throws RemoteException 
    {
	super();
        if (args.length < 2)
        {
            System.err.println("Usage: AppServerImpl <host> <port>");
            System.exit(1);
        }    
        host = args[0];
        port = Integer.parseInt(args[1]);
    }

    public XUtil getXUtil(String url, java.util.Properties p) throws RemoteException, java.io.IOException, Exception  
    {
	// just a simple example of passing back a remote object
	XUtil x = new RMIUtilImpl(url, p); 
	return x;
    }

    public XUtil getXUtil(IWorkspace w, java.util.Properties p)
        throws RemoteException, java.io.IOException, Exception
    {
        XUtil x = new RMIUtilImpl(w, p);
        return x;   
    }
    public XUtil getXUtil(IDataService w, java.util.Properties p)
        throws RemoteException, java.io.IOException, Exception
    {
        XUtil x = new RMIUtilImpl(w, p);
        return x;   
    }
        
          
    public static void main(String[] args) {
	AppServer server  = null;
	try {
	    server = new AppServerImpl(args);
	}
	catch(Exception e1) {
	    e1.printStackTrace();
	    System.exit(1);
	}
        try {
	    Naming.rebind("//"+host+":"+port+"/AppServer",server);
	}
	catch(Exception e) {
	    try {
		System.out.println("creating registry ...");
		LocateRegistry.createRegistry(port);
		Naming.rebind("//"+host+":"+port+"/AppServer",server);
	    }
	    catch(Exception e2) {
		e2.printStackTrace();
		System.exit(1);
	    }
        }
	System.out.println("waiting for clients...");
    }
}
