package com.sas.services.connection;
//
// History:
//
// Date    Name            Remarks
// 26Apr02 B Beers         S0149086: Revise the connection factory interface.
// 03May02 B Beers         S0149086: Removed obsolete methods.
// 11Oct02 B Beers         S0168379: Generalize connection service for other servers.
//
/**
 * Implementation class for ConnectionFactoryInterface.
 * @author Biff Beers
 */
public class ConnectionFactory extends ConnectionFactoryShell implements ConnectionFactoryInterface
{
     protected ConnectionFactory()
     {
     }

     public ConnectionInterface getConnection() throws ConnectionFactoryException
     {
          return getConnection(null,null,null,0L);
     }

     public ConnectionInterface getConnection(String domain) throws ConnectionFactoryException
     {
          return getConnection(null,null,domain,0L);
     }

     public ConnectionInterface getConnection(long waitMilliseconds) throws ConnectionFactoryException
     {
          return getConnection(null,null,null,waitMilliseconds);
     }

     public ConnectionInterface getConnection(String domain,long waitMilliseconds) throws ConnectionFactoryException
     {
          return getConnection(null,null,domain,waitMilliseconds);
     }

     public ConnectionInterface getConnection(String userName,String password) throws ConnectionFactoryException
     {
          return getConnection(userName,password,null,0L);
     }

     public ConnectionInterface getConnection(String userName,String password,String domain) throws ConnectionFactoryException
     {
          return getConnection(userName,password,domain,0L);
     }

     public ConnectionInterface getConnection(String userName,String password,long waitMilliseconds) throws ConnectionFactoryException
     {
          return getConnection(userName,password,null,waitMilliseconds);
     }

     public ConnectionInterface getConnection(String userName,String password,String domain,long waitMilliseconds) throws ConnectionFactoryException
     {
          if (userName == null)
          {
               userName = "";
          }

          if (password == null)
          {
               password = "";
          }

          return getConnection(new PasswordCredential(userName,password,domain),waitMilliseconds);
     }

     public ConnectionFactoryAdminInterface getAdminInterface() throws ConnectionFactoryException
     {
          return getAdminInterface(null,null);
     }

     public ConnectionFactoryAdminInterface getAdminInterface(String adminName,String password) throws ConnectionFactoryException
     {
          if (adminName == null)
          {
               adminName = "";
          }

          if (password == null)
          {
               password = "";
          }

          return getAdminInterface(new PasswordCredential(adminName,password));
     }
}