package com.sas.services.connection;
//
// History:
//
// Date    Name            Remarks
// 26Apr02 B Beers         S0149086: Revise the connection factory interface.
//
/**
 * An interface implemented by factory users who want to be notified of important events such as factory shutdown.
 * @author Biff Beers
 * @see com.sas.services.connection.ConnectionFactoryShellInterface#addConnectionFactoryEventListener(com.sas.services.connection.ConnectionFactoryEventListener)
 * @see com.sas.services.connection.ConnectionFactoryShellInterface#removeConnectionFactoryEventListener(com.sas.services.connection.ConnectionFactoryEventListener)
 */
public interface ConnectionFactoryEventListener
{
     /**
      * Delivers a connection factory event.
      * @param event a connection factory event
      */
     void handleConnectionFactoryEvent(ConnectionFactoryEvent event);
}