/* $Id: ExpiredCredentialsException.java,v 1.1.22.1 2005/10/11 17:14:12 sasbfb Exp $ */
package com.sas.services.connection;
//
// History:
//
// Date    Name            Remarks
// 29Oct02 B Beers         S0156049: Added support for expired credentials.
// 11Oct05 B Beers         S0324947: Added serialVersionUID.
/**
 * The connection factory rasies an expired credentials exception when a 
 * connection request cannot be granted due to credentials that were valid
 * but have expired.
 * @author Biff Beers
 */
public class ExpiredCredentialsException extends LoginException
{
     /**
      * No-arg constructor.
      */
     public ExpiredCredentialsException()
     {
          super();
     }

     /**
      * Construct a connection factory exception with a message.
      * @param msg a message providing further details about the exception
      */
     public ExpiredCredentialsException(String msg)
     {
          super(msg);
     }

     /**
      * Construct a connection factory exception with a nested exception.
      * @param nestedException the exception that caused this exception
      */
     public ExpiredCredentialsException(Throwable nestedException)
     {
          super(nestedException);
     }

     /**
      * Construct a connection factory exception with a message and a nested exception.
      * @param msg a message providing further details about the exception
      * @param nestedException the exception that caused this exception
      */
     public ExpiredCredentialsException(String msg,Throwable nestedException)
     {
          super(msg,nestedException);
     }
     
     /**
      * Serial version ID. 
      * This value should be changed if this version is not compatible with the previous version.
      */
     private static final long serialVersionUID = 566521429244628796L;
}