/* $Id$ */
package com.sas.services.connection;
//
// History:
//
// Date    Name            Remarks
// 26Nov01 B Beers         S0133039: Created.
// 26Apr02 B Beers         S0149086: Revise the connection factory interface.
// 11Oct05 B Beers         S0324947: Added serialVersionUID.
/**
 * A exception that is so severe that a factory which throws this exception
 * can no longer be used. The factory will automatically destroy itself
 * when it throws this exception.
 * @author Biff Beers
 */
public class FatalConnectionFactoryException extends ConnectionFactoryException
{
     /**
      * No-arg constructor.
      */
     public FatalConnectionFactoryException()
     {
          super();
     }

     /**
      * Construct a connection factory exception with a message.
      * @param msg a message providing further details about the exception
      */
     public FatalConnectionFactoryException(String msg)
     {
          super(msg);
     }

     /**
      * Construct a connection factory exception with a nested exception.
      * @param nestedException the exception that caused this exception
      */
     public FatalConnectionFactoryException(Throwable nestedException)
     {
          super(nestedException);
     }

     /**
      * Construct a connection factory exception with a message and a nested exception.
      * @param msg a message providing further details about the exception
      * @param nestedException the exception that caused this exception
      */
     public FatalConnectionFactoryException(String msg,Throwable nestedException)
     {
          super(msg,nestedException);
     }
     
     /**
      * Serial version ID. 
      * This value should be changed if this version is not compatible with the previous version.
      */
     private static final long serialVersionUID = -3384157314578093571L;
}