package com.sas.services.connection;

import java.util.logging.Logger;
//
// History:
//
// Date    Name            Remarks
// 10Jan03 B Beers         S0177764: Use java.util.logging package and application monitoring.
//
/**
 * The interface creating loggers for the connection factory. This interface
 * is used internally by the <CODE>ConnectionFactoryManager</CODE>.
 * @author Biff Beers
 */
public abstract class LoggerFactory
{
     /**
      * This method is used internally by the <CODE>ConnectionFactoryManager</CODE>.
      * @param cxfConfig the configuration for a connection factory that needs a logger
      * @return a logger for the connection factory
      * @exception com.sas.services.connection.ConnectionFactoryException if an exception is
      * thrown while creating the logger
      */
     protected abstract Logger getLogger(ConnectionFactoryConfiguration cxfConfig) throws ConnectionFactoryException;
}