package com.sas.services.connection;

import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.logging.Formatter;
import java.util.logging.LogRecord;
//
// History:
//
// Date    Name            Remarks
// 10Jan03 B Beers         S0177764: Use java.util.logging package and application monitoring.
//
/**
 * The formatter for formatting messages sent to an application monitor.
 * This class is used internally by the <CODE>ConnectionFactoryManager</CODE>.
 * @author Biff Beers
 */
public class MonitorFormatter extends Formatter
{
     public String format(LogRecord logRecord)
     {
          if (!(logRecord instanceof MonitorRecord))
          {
               String message = formatMessage(logRecord);
               return message;
          }

          MonitorRecord monitorRecord = (MonitorRecord)logRecord;
          Map contents = monitorRecord.getContents();
          Set entrySet = contents.entrySet();
          Iterator entryItor = entrySet.iterator();
          StringBuffer sb = new StringBuffer();

          while (entryItor.hasNext())
          {
               Map.Entry entry = (Map.Entry)entryItor.next();
               String name = (String)entry.getKey();
               String value = (String)entry.getValue();
               sb.append(name).append("=\"").append(value).append("\" ");
          }

          // remove trailing blank
          int length = sb.length();
          sb.setLength(length-1);
          String message = sb.toString();
          return message;
     }
}