/* $Id$ */
// Copyright (c) 2001-2004 SAS Institute Inc., Cary, NC 27513
//All Rights Reserved.
package com.sas.services.webdav.tools;

// DAVResource imports
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragSource;
import java.awt.dnd.DragSourceDragEvent;
import java.awt.dnd.DragSourceDropEvent;
import java.awt.dnd.DragSourceEvent;
import java.awt.dnd.DragSourceListener;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.*;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.rmi.RemoteException;
import java.security.AccessController;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.TreeMap;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JPopupMenu;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.KeyStroke;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.border.BevelBorder;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.commons.httpclient.HttpStatus;
import org.apache.webdav.lib.methods.DepthSupport;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.Text;
import org.xml.sax.SAXException;

import com.sas.services.util.GetPropertyAction;
import com.sas.services.util.XMLUtil;
import com.sas.services.webdav.ConnectionInfo;
import com.sas.services.webdav.DAVException;
import com.sas.services.webdav.DAVResource;
import com.sas.services.webdav.Utils;
import com.sas.text.Message;

/**
 * Displays DAV information in a JTree
 * 
 * @author Rob Owen
 * @version 1.0 12-Dec-2001
 */
public class DAVTree extends JFrame implements TreeSelectionListener, ClipboardOwner {

   private static final long serialVersionUID = 3257853194444026935L;
   private static final boolean traceEnabled = false;
    private JTree jTree;
    private JTable jTable;
    private JSplitPane sp;
    private JLabel status;
    private Vector resNameVector = new Vector();
    private Vector resValueVector = new Vector();
    private static Vector resNSVector = new Vector();
    private TableModel tbModel = null;
    private String urlLoc;
    private String _userid = null;
    private String _password = null;
    private DAVTreeNode top = null;
    private DOMTree domTree = new DOMTree();
    private DefaultTreeModel dtModel = null;
    private JPopupMenu treeMenu;
    private JMenuItem miCopyClipboard;
    private DAVResource _r;
    //	private DocumentBuilder db = null;
    private int screenHeight, screenWidth;
    private static Properties properties = new Properties();
    private static int FRAME_WIDTH = 800;
    private static int FRAME_HEIGHT = 500;
    //	private static Color COLOR_TABLE_BACKGROUND = new Color( 220, 240, 255
    // );
    //	private static Color COLOR_TREE_BACKGROUND = new Color( 220, 240, 255 );
    private static Color COLOR_TABLE_BACKGROUND = Color.WHITE;
    private static Color COLOR_TREE_BACKGROUND = Color.WHITE;
    private static Color COLOR_TREE_SELECTION = COLOR_TREE_BACKGROUND.darker();
    private static Color COLOR_TABLE_FOREGROUND = Color.BLUE;
    private static Color COLOR_TREE_FOREGROUND = Color.BLUE;
    //	private static Color COLOR_TABLE_GRID = new Color( 220, 220, 255 );
    private static Color COLOR_TABLE_BACKGROUND_COLUMN1 = new Color(248, 248, 248);
    private static Color COLOR_TABLE_FOREGROUND_COLUMN1 = Color.BLUE;
    private static final Font treeFont = new Font("SanSerif", Font.PLAIN, 11);
    private static final Font tableFont = new Font("SanSerif", Font.PLAIN, 11);
    private static final Font tableFontBold = new Font("SanSerif", Font.BOLD, 11);
    private static final Font DIALOG_FONT = new Font("SanSerif", Font.PLAIN, 11);
    private static final String XMLHEADER = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
    private static boolean DEBUG = false;
    private static final String P_WINDOWHEIGHT = "window.height";
    private static final String P_WINDOWWIDTH = "window.width";
    private static final String P_TBBC = "table.background.color";
    private static final String P_TBFC = "table.foreground.color";
    private static final String P_TRBC = "tree.background.color";
    private static final String P_TRFC = "tree.foreground.color";
    private static final String P_TBBCC1 = "table.background.color.column1";
    private static final String P_TBFCC1 = "table.foreground.color.column1";
    private static final String version = "1.4.3";
    private static final String tmpdir = System.getProperty("java.io.tmpdir");
    private ImageIcon resImage = new ImageIcon(this.getClass().getClassLoader().getResource("com/sas/services/webdav/tools/resource.gif"));
    // private ImageIcon colImage = new ImageIcon(this.getClass().getClassLoader().getResource("collection.gif"));
    HistoryComboBox hCombo = new HistoryComboBox();
    public String historyFileName = "history.dat";
    JMenuBar mainMenuBar;
    JMenu menu1, menu2, menu3;
    JMenuItem miOpen, miTest1, miExit, miDelete, miAdd, miModify, miClone, miRefresh, miSearch, miContents;
    JOptionPane chk = new JOptionPane();
    DocumentBuilderFactory factory = null;
    DocumentBuilder builder = null;
    Document doc = null;
    boolean inDragDrop = false;
    File dndFile = null;
    String dndString = null;
    static {
        try {
            FileInputStream fin = new FileInputStream("DAVTree.properties");
            properties.load(fin);
            String p = null;
            p = (String) properties.get(P_WINDOWHEIGHT);
            if (p != null) FRAME_WIDTH = Integer.parseInt((String) properties.get(P_WINDOWHEIGHT));
            p = (String) properties.get(P_WINDOWWIDTH);
            if (p != null) FRAME_WIDTH = Integer.parseInt((String) properties.get(P_WINDOWWIDTH));
            p = (String) properties.get(P_WINDOWHEIGHT);
            if (p != null) FRAME_HEIGHT = Integer.parseInt((String) properties.get(P_WINDOWHEIGHT));
            p = (String) properties.get(P_TBBC);
            if (p != null) COLOR_TABLE_BACKGROUND = ColorFromRGB((String) properties.get(P_TBBC));
            p = (String) properties.get(P_TBFC);
            if (p != null) COLOR_TABLE_FOREGROUND = ColorFromRGB((String) properties.get(P_TBFC));
            p = (String) properties.get(P_TRBC);
            if (p != null) COLOR_TREE_BACKGROUND = ColorFromRGB((String) properties.get(P_TRBC));
            p = (String) properties.get(P_TRFC);
            if (p != null) COLOR_TREE_FOREGROUND = ColorFromRGB((String) properties.get(P_TRFC));
            p = (String) properties.get(P_TBBCC1);
            if (p != null) COLOR_TABLE_BACKGROUND_COLUMN1 = ColorFromRGB((String) properties.get(P_TBBCC1));
            p = (String) properties.get(P_TBFCC1);
            if (p != null) COLOR_TABLE_FOREGROUND_COLUMN1 = ColorFromRGB((String) properties.get(P_TBFCC1));
        } catch (IOException ioe) {
            // Ignore, file does not have to exist
        }
    }

    /**
     * Converts an RGB string read from a configuration file to a Color.
     * 
     * @param RGBString -
     *            a string of the format r,g,b (where r, g, b are the color
     *            components. All values from [0..255].
     * @return Color The color created from the RGBString
     */
    private static Color ColorFromRGB(String RGBString) {
        int r = 0, g = 0, b = 0;
        try {
            String colval = null;
            int p1 = 0, p2;
            p2 = RGBString.indexOf(',', p1);
            colval = RGBString.substring(p1, p2);
            r = Integer.parseInt(colval);
            p1 = p2 + 1;
            p2 = RGBString.indexOf(',', p1);
            colval = RGBString.substring(p1, p2);
            g = Integer.parseInt(colval);
            p1 = p2 + 1;
            p2 = RGBString.indexOf(',', p1);
            colval = RGBString.substring(p1);
            b = Integer.parseInt(colval);
        } catch (NumberFormatException nfe) {
            // We are ignoring these errors at the moment
        }
        return new Color(r, g, b);
    }

    public DAVTree(String url) {
        urlLoc = url;
        try {
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel"/* I18nOK:EMS */);
        } catch (Exception e) {
            // Ignore this possibility
        }

        setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

        setTitle(Message.format(RB.getResources(), "DAVTree.application.txt", version));
        
        // Kick off the splash screen.
        Splash splashWin = new Splash(this, 15000);

        Toolkit toolkit = Toolkit.getDefaultToolkit();
        Dimension dim = toolkit.getScreenSize();
        screenHeight = dim.height;
        screenWidth = dim.width;
        // This should display a WIDTH x HEIGHT sized Frame in the middle of
        // the screen
        setBounds((screenWidth - FRAME_WIDTH) / 2, (screenHeight - FRAME_HEIGHT) / 2, FRAME_WIDTH, FRAME_HEIGHT);
        getContentPane().setLayout(new BorderLayout());
        // Set up a document builder
        try {
            factory = DocumentBuilderFactory.newInstance();
            factory.setValidating(false);
            factory.setNamespaceAware(true);
            builder = factory.newDocumentBuilder();
            doc = builder.newDocument();
        } catch (ParserConfigurationException e) {
            e.printStackTrace(); // Unable to get a parser or parse document
        }
        // Take a DOM and convert it to a Tree model for the JTree
        if (url.length() > 0) {
            top = new DAVTreeNode(urlLoc, true);
            //			boolean addedNodes = top.populateCollections( true );
            top.resName = top.fullName;
            dtModel = new DefaultTreeModel(top);
        } else {
            dtModel = new DefaultTreeModel(new DefaultMutableTreeNode());
            dtModel.setRoot(null);
        }
        // Create our JTree
        jTree = new DNDTree(dtModel, true, true) {

            private static final long serialVersionUID = 3256719593677862960L;

            public String getPathName(TreePath path) {
                Object o = path.getLastPathComponent();
                if (o instanceof DAVTreeNode) return ((DAVTreeNode) o).fullName;
                return null;
            }
        };
        jTree.addTreeSelectionListener(this);
        jTree.addTreeExpansionListener(new TreeExpansionHandler());
        jTree.setBackground(COLOR_TREE_BACKGROUND);
        tbModel = new AbstractTableModel() {

            private static final long serialVersionUID = 3257846575916267059L;
            //private final String[] colNames = {"Property Names", "Property
            // Values"};
            private final String[] colNames = { RB.getStringResource("DAVTree.namecolumnlabel.txt"/* I18nOK:EMS */),
                    RB.getStringResource("DAVTree.valuecolumnlabel.txt"/* I18nOK:EMS */)};

            public String getColumnName(int col) {
                return colNames[col].toString();
            }

            public int getColumnCount() {
                return 2;
            }

            public int getRowCount() {
                return resNameVector.size();
            }

            public Object getValueAt(int row, int col) {
                if (col == 0) return resNameVector.elementAt(row);
                else return resValueVector.elementAt(row);
            }
        };
        // Create our JTable
        jTable = new JTable(tbModel);
        jTable.setGridColor(COLOR_TREE_SELECTION);
        jTable.setForeground(COLOR_TABLE_FOREGROUND);
        jTable.setBackground(COLOR_TABLE_BACKGROUND);
        jTable.setFont(tableFont);
        domTree.setBackground(COLOR_TABLE_BACKGROUND);
        CustomTableCellRenderer renderer = new CustomTableCellRenderer();
        renderer.setBackground(COLOR_TABLE_BACKGROUND_COLUMN1);
        renderer.setForeground(COLOR_TABLE_FOREGROUND_COLUMN1);
        renderer.setFont(tableFontBold);
        jTable.getColumnModel().getColumn(0).setCellRenderer(renderer);
        for (int i = 0; i < 2; i++) {
            if (i == 0) {
                TableColumn col = jTable.getColumnModel().getColumn(0);
                col.setWidth(75);
                col.setPreferredWidth(75);
                col.sizeWidthToFit();
            } else {
                TableColumn col = jTable.getColumnModel().getColumn(1);
                col.setWidth(375);
                col.setPreferredWidth(375);
            }
        }
        jTable.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
        jTable.setShowGrid(false);
        jTable.setIntercellSpacing(new Dimension(0, 0));
        jTable.getColumnModel().setColumnMargin(2);
        // Create the split pane
        JScrollPane treePane = new JScrollPane(jTree);
        JScrollPane tablePane = new JScrollPane(jTable);
        JScrollPane domTreePane = new JScrollPane(domTree);
        tablePane.setBackground(COLOR_TABLE_BACKGROUND);
        tablePane.getViewport().setBackground(COLOR_TABLE_BACKGROUND);
        domTreePane.setBackground(COLOR_TABLE_BACKGROUND);
        domTreePane.getViewport().setBackground(COLOR_TABLE_BACKGROUND);
        treePane.setMinimumSize(new Dimension(190, treePane.getPreferredSize().height));
        sp = new JSplitPane();
        sp.setDividerLocation(0.33);
        JTabbedPane tabbedPane = new JTabbedPane();
        // tabbedPane.setBackground( COLOR_TABLE_BACKGROUND );
        String tabLabel = RB.getStringResource("DAVTree.tabletab.label.txt");
        String tabDesc = RB.getStringResource("DAVTree.tabletab.desc.txt");
        tabbedPane.addTab(tabLabel, null, tablePane, tabDesc);
        tabLabel = RB.getStringResource("DAVTree.xmltab.label.txt");
        tabDesc = RB.getStringResource("DAVTree.xmltab.desc.txt");
        tabbedPane.addTab(tabLabel, null, domTreePane, tabDesc);
        tabbedPane.setSelectedIndex(0);
        sp.setLeftComponent(treePane);
        sp.setRightComponent(tabbedPane);
        // sp.setBackground( COLOR_TABLE_BACKGROUND );
        // We have no tree listener but this looks more natrual
        jTree.getSelectionModel().setSelectionMode(TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION);
        jTree.setShowsRootHandles(true);
        CustomBasicRenderer btcr = new CustomBasicRenderer();
        btcr.setBackgroundNonSelectionColor(COLOR_TREE_BACKGROUND);
        btcr.setBackgroundSelectionColor(COLOR_TREE_SELECTION);
        btcr.setTextSelectionColor(Color.WHITE);
        btcr.setFont(treeFont);
        jTree.setCellRenderer(btcr);
        jTree.setEditable(false);
        //		MouseListener ml = new MouseAdapter() {
        //				public void mousePressed(MouseEvent e) {
        //					int selRow = jTree.getRowForLocation(e.getX(), e.getY());
        //					TreePath selPath = jTree.getPathForLocation(e.getX(), e.getY());
        //					if(selRow != -1) {
        //						if(e.getClickCount() == 2) {
        //							DefaultMutableTreeNode dmt =
        //								(DefaultMutableTreeNode)selPath.getLastPathComponent();
        //						}
        //					}
        //				}
        //			};
        //		jTree.addMouseListener(ml);
        jTree.addMouseListener(new MouseAdapter() {

            public void mousePressed(MouseEvent e) {
                int selectedRow = jTree.getRowForLocation(e.getX(), e.getY());
                if (selectedRow != -1) {
                    if (SwingUtilities.isRightMouseButton(e) == true) {
                        jTree.setSelectionRow(selectedRow);
                        treeMenu.show(jTree, e.getX(), e.getY());
                    }
                }
            }
        });
        ProcessActions processAction = new ProcessActions();
        // setup the menu
        mainMenuBar = new JMenuBar();
        menu1 = new JMenu(RB.getStringResource("DAVTree.menu.file.txt"/* I18nOK:EMS */));
        miOpen = new JMenuItem(RB.getStringResource("DAVTree.menu.file.open.txt"/* I18nOK:EMS */));
        miOpen.addActionListener(processAction);
        menu1.add(miOpen);
        menu1.addSeparator();
        miExit = new JMenuItem(RB.getStringResource("DAVTree.menu.file.exit.txt"/* I18nOK:EMS */));
        menu1.add(miExit);
        miExit.addActionListener(processAction);
        mainMenuBar.add(menu1);
        menu2 = new JMenu(RB.getStringResource("DAVTree.menu.edit.txt"/* I18nOK:EMS */));
        miDelete = new JMenuItem(RB.getStringResource("DAVTree.menu.edit.delete.txt"/* I18nOK:EMS */));
        miDelete.setAccelerator(KeyStroke.getKeyStroke("DELETE"));
        menu2.add(miDelete);
        miDelete.addActionListener(processAction);
        miAdd = new JMenuItem(RB.getStringResource("DAVTree.menu.edit.add.txt"/* I18nOK:EMS */));
        menu2.add(miAdd);
        miAdd.addActionListener(processAction);
        miModify = new JMenuItem(RB.getStringResource("DAVTree.menu.edit.modify.txt"/* I18nOK:EMS */));
        menu2.add(miModify);
        miModify.addActionListener(processAction);
        miClone = new JMenuItem(RB.getStringResource("DAVTree.menu.edit.clone.txt"/* I18nOK:EMS */));
        miClone.setEnabled(false);
        menu2.add(miClone);
        mainMenuBar.add(menu2);
        menu3 = new JMenu(RB.getStringResource("DAVTree.menu.view.txt"/* I18nOK:EMS */));
        miRefresh = new JMenuItem(RB.getStringResource("DAVTree.menu.view.refresh.txt"/* I18nOK:EMS */));
        miSearch = new JMenuItem(RB.getStringResource("DAVTree.menu.view.search.txt"/* I18nOK:EMS */));
        miSearch.setEnabled(false);
        miContents = new JMenuItem(RB.getStringResource("DAVTree.menu.view.contents.txt"/* I18nOK:EMS */));
        menu3.add(miRefresh);
        miRefresh.addActionListener(processAction);
        menu3.add(miSearch);
        menu3.add(miContents);
        miContents.addActionListener(processAction);
        mainMenuBar.add(menu3);
        setJMenuBar(mainMenuBar);
        treeMenu = new JPopupMenu();
        treeMenu.setInvoker(jTree);
        treeMenu.setVisible(false);
        miCopyClipboard = new JMenuItem("Copy URI to clipboard");
        treeMenu.add(miCopyClipboard);
        miCopyClipboard.addActionListener(processAction);
        final String userHome = (String) AccessController
                .doPrivileged(new GetPropertyAction("user.home"/* I18nOK:EMS */));
        final String fileSeparator = (String) AccessController
                .doPrivileged(new GetPropertyAction("file.separator"/* I18nOK:EMS */));
        if (userHome != null) historyFileName = userHome + fileSeparator + historyFileName; /* I18nOK:COS */
        hCombo.load(historyFileName);
        hCombo.setPreferredSize(new Dimension(280, hCombo.getPreferredSize().height));

        // Add a WindowListener so that we can close the window
        WindowListener wndCloser = new WindowAdapter() {

            public void windowClosing(WindowEvent e) {
                hCombo.save(historyFileName);
                exit();
            }
        };
        addWindowListener(wndCloser);
        getContentPane().add(sp, BorderLayout.CENTER);

        // StatusBar
        status = new JLabel(">", SwingConstants.HORIZONTAL);
        status.setHorizontalAlignment(SwingConstants.LEFT);
        status.setBorder( BorderFactory.createBevelBorder(BevelBorder.LOWERED) );
        getContentPane().add(status, BorderLayout.SOUTH);

        validate();
        try { 
            Thread.sleep(1500); 
        } catch ( InterruptedException e ) {
            // giving splash screen a chance
        }
        
        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        splashWin.dispose();

        setVisible(true);
    }
    
    protected DAVResource getDAVResource(String url) {
        if (_r == null) {
            ConnectionInfo hostInfo = new ConnectionInfo(url, _userid, _password);
            try {
                try {
                    _r = new DAVResource(hostInfo, null);
                } catch (DAVException e) {
                    if (e.getStatusCode() == HttpStatus.SC_UNAUTHORIZED) {
                        CredentialsDlg dlg = new CredentialsDlg(this, true);
                        dlg.pack();
                        dlg.show();
                        if (_userid == null || _password == null) System.exit(4);
                        hostInfo.setUser(_userid);
                        hostInfo.setPW(_password);
                        _r = new DAVResource(hostInfo, null);
                    } else throw e;
                }
                if (_r == null) System.out.println(RB.getStringResource("DAVTree.errcreate.txt"));
                else if (DEBUG) _r.setDebug(Integer.MAX_VALUE);
            } catch (DAVException e) {
                System.out.println("DAVException: " + e.getMessage() + "\n" + e.toString());
                status.setText(e.getMessage());
            }
        } else {
            try {
                URL _url = new URL(url);
                _r.setPath(_url.getPath());
            } catch (MalformedURLException e) {
                System.out.println("MalformedURLException: " + e.getMessage() + "\n" + e.toString());
                status.setText(e.getMessage());
            }
        }
        return _r;
    }
    
   protected Map getChildrenList(String fullName) {
        Map children = new HashMap();
        try {
            DAVResource _resource = getDAVResource(fullName);
            if (_resource != null) {
                int savedDepth = _resource.getDepth();
                _resource.setDepth(DepthSupport.DEPTH_1);
                org.apache.webdav.lib.Property[] pp = _resource.getProperty("<D:resourcetype/>");
                _resource.setDepth( savedDepth );
                URL u = _resource.getURL();
                for (int i = 0; i < pp.length; i++) {
                    String newurl = pp[i].getOwningURL();
                    if (newurl.indexOf("://") < 0) {
                        String tempurl = u.getProtocol() + "://" + u.getHost();
                        if (u.getPort() != -1 && u.getPort() != 80) tempurl = tempurl + ":" + u.getPort();
                        newurl = tempurl + newurl; /* I18nOK:COS */
                    }
                    if (!isSameUrl(fullName, newurl)) children.put(newurl, pp[i].getPropertyAsString());
                }
            }
        } catch (DAVException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        }
        return children;
    }

    protected TreeMap getProperties(String fullName) {
        TreeMap ht = null;
        try {
            DAVResource _resource = getDAVResource(fullName);
            int savedDepth = _resource.getDepth();
            _resource.setDepth(DepthSupport.DEPTH_0);
            org.apache.webdav.lib.Property[] pp = _resource.getProperties();
            _resource.setDepth(savedDepth);
            ht = new TreeMap();
            for (int i = 0; i < pp.length; i++) {
                Element pVal = pp[i].getElement();
                String nodeText = "";
                if (pVal.hasChildNodes()) {
                    if (pVal.getFirstChild() == pVal.getLastChild() && pVal.getFirstChild() instanceof Text) {
                        nodeText = pVal.getFirstChild().getNodeValue();
                    }
                }
                if (nodeText.equals("")) nodeText = XMLUtil.node2String(pVal);
                ht.put(pp[i].getName(), pVal);
            }
        } catch (DAVException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        }
        return ht;
    }
    

    public void lostOwnership(Clipboard clipboard, Transferable contents) {
        // Nothing to do here
    }

    private boolean isSameUrl(String url1, String url2) {
      String _url1 = stripTrailingSlashes(url1.trim());
      String _url2 = stripTrailingSlashes(url2.trim());
      if (_url1.charAt(_url1.length() - 1) == '/') _url1 = _url1.substring(0, _url1.length() - 1);
      if (_url2.charAt(_url2.length() - 1) == '/') _url2 = _url2.substring(0, _url2.length() - 1);
      return (_url1.equals(_url2));
    }

    public void valueChanged(TreeSelectionEvent e) {
        DAVTreeNode node = (DAVTreeNode) jTree.getLastSelectedPathComponent();
        if (node == null) return;
        if (node.DAVprops == null) node.DAVprops = getProperties(node.fullName);
        setupVectors(node.DAVprops);
        ((AbstractTableModel) tbModel).fireTableDataChanged();
        DocumentFragment docfrg = doc.createDocumentFragment();
        Iterator props = node.DAVprops.values().iterator();
        Node n;
        while (props.hasNext()) {
            n = doc.importNode((Node) props.next(), true);
            docfrg.appendChild(n);
        }
        domTree.setRoot(docfrg);
    }

    private void setupVectors(TreeMap DAVprops) {
        Iterator keys = null;
        Iterator values = null;
        // Clear the display vectors
        resNameVector.clear();
        resValueVector.clear();
        resNSVector.clear();
        // Make vectors
        if (DAVprops != null) {
            keys = DAVprops.keySet().iterator();
            values = DAVprops.values().iterator();
            Element pVal;
            while (keys.hasNext()) {
                resNameVector.add(keys.next());
            }
            while (values.hasNext()) {
                pVal = (Element) values.next();
                String nodeText = "";
                if (pVal.hasChildNodes()) {
                    if (pVal.getFirstChild() == pVal.getLastChild() && pVal.getFirstChild() instanceof Text) {
                        nodeText = pVal.getFirstChild().getNodeValue();
                    }
                }
                if (nodeText.equals("")) nodeText = XMLUtil.node2String(pVal);
                resValueVector.add(nodeText);
                resNSVector.add(pVal.getNamespaceURI());
            }
        }
    }

    /**
     * A common point of exit...
     */
    private static void exit() {
        System.exit(0);
    }

    public static void main(String[] args) {
        final String priority = (String) AccessController
                .doPrivileged(new GetPropertyAction("logLevel"/* I18nOK:EMS */));
        DEBUG = ((priority != null) && (priority.equals("DEBUG")));
        if (args.length == 0) {
            new DAVTree("");
        } else {
            new DAVTree(args[0]);
        }
    }
    // This class is a custom renderer based on TreeCellRenderer
    protected class CustomBasicRenderer extends DefaultTreeCellRenderer {

      private static final long serialVersionUID = 3256725099926009398L;
      Font fontPlain, fontBold;

        public CustomBasicRenderer() {
            fontPlain = new Font("SanSerif", Font.PLAIN, 11);
            fontBold = new Font("SanSerif", Font.BOLD, 11);
        }

        public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded,
                boolean leaf, int row, boolean hasFocus) {
            // Allow the original renderer to set up the label
            Component c = super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);
            // Now change the icon and text position
            if (c instanceof JLabel) {
                JLabel l = (JLabel) c;
                l.setBackground(COLOR_TREE_BACKGROUND);
                l.setForeground(COLOR_TREE_FOREGROUND);
            }
            if (value instanceof DAVTreeNode) {
                if (((DAVTreeNode) value).isCollection) {
                    // setIcon(colImage);
                    setFont(fontBold);
                } else {
                    setIcon(resImage);
                    setFont(fontPlain);
                }
            }
            return c;
        }
    }
    // This class is a custom renderer based on TableCellRenderer
    protected class CustomTableCellRenderer extends DefaultTableCellRenderer {

      private static final long serialVersionUID = 3256720671764983860L;

      public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected,
                boolean hasFocus, int row, int col) {
            // Allow the original renderer to set up the label
            Component c = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, col);
            setToolTipText((String) resNSVector.elementAt(row));
            return c;
        }
    }
    private class ProcessActions implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            Object object = e.getSource();
            if (object == miOpen) miOpen_Action(e);
            else if (object == miContents) miContents_Action(e);
            else if (object == miExit) miExit_Action(e);
            else if (object == miDelete) miDelete_Action(e);
            else if (object == miAdd) miAdd_Action(e);
            else if (object == miModify) miModify_Action(e);
            else if (object == miRefresh) miRefresh_Action(e);
            else if (object == miCopyClipboard) miCopyClipboard_Action(e);
        }
    }

    public void miCopyClipboard_Action(ActionEvent e) {
        DAVTreeNode node = (DAVTreeNode) jTree.getLastSelectedPathComponent();
        String url = node.fullName;
        StringSelection stringSelection = new StringSelection(url);
        Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
        clipboard.setContents(stringSelection, this);
    }

    public void miExit_Action(ActionEvent e) {
        if (_r != null) {
            try {
                _r.close();
            } catch (RemoteException ex) {
                // Ignore this possibility
            }
            _r = null;
        }
        Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
    }

    public void miOpen_Action(ActionEvent e) {
        OpenDlg opendlg = new OpenDlg(this, RB.getStringResource("DAVTree.openhdr.txt"/* I18nOK:EMS */), RB
                .getStringResource("DAVTree.opendesc.txt"/* I18nOK:EMS */));
        opendlg.show();
        _userid = null;
        _password = null;
        status.setText(" ");
        if (_r != null) {
            try {
                _r.close();
            } catch (RemoteException ex) {
                // Just null out the reference
            }
            _r = null;
        }
        top = new DAVTreeNode(urlLoc, true);
        boolean addedNodes = top.populateCollections(this, true);
        if (addedNodes) {
            top.resName = top.fullName;
            dtModel.setRoot(top);
        }
    }

    public void miContents_Action(ActionEvent e) {
        DAVTreeNode node = (DAVTreeNode) jTree.getLastSelectedPathComponent();
        if (node == null) return;
        try {
            URL _url = new URL(node.fullName);
            _r.setPath( _url.getPath() );
            HexDisplayDlg hexdlg = new HexDisplayDlg(this, node.fullName, _r.getContents());
            hexdlg.show();
        } catch (MalformedURLException mue ) {
            mue.printStackTrace();
        } catch (DAVException de) {
            System.out.println(de.getMessage());
            de.printStackTrace();
        } catch (RemoteException re) {
            System.out.println("RemoteException: " + re.getMessage());
            re.printStackTrace();
        }
    }

    public void miRefresh_Action(ActionEvent e) {
        //		DAVTreeNode node =
        // (DAVTreeNode)jTree.getLastSelectedPathComponent();
        //if (node == null) {
        top = new DAVTreeNode(urlLoc, true);
        boolean addedNodes = top.populateCollections(this, true);
        if (addedNodes) {
            top.resName = top.fullName;
            dtModel.setRoot(top);
        }
    }

    public void miDelete_Action(ActionEvent e) {
        DAVTreeNode node;
        int selval;
        boolean doAll = false;
        boolean jumpOut = false;
        Object[] options = { RB.getStringResource("DAVTree.yes.txt"), RB.getStringResource("DAVTree.yesall.txt"),
                RB.getStringResource("DAVTree.no.txt"), RB.getStringResource("DAVTree.cancel.txt")};
        TreePath[] selpaths = jTree.getSelectionPaths();
        for (int i = 0; i < selpaths.length; i++) {
            if (jumpOut) break;
            node = (DAVTreeNode) selpaths[i].getLastPathComponent();
            // if (node == null) return;
            try {
                DAVResource _resource = getDAVResource(node.fullName);
                if (!doAll) {
                    selval = JOptionPane.showOptionDialog(this, Message.format(RB.getResources(),
                            "DAVTree.delcheck.fmt.txt"/* I18nOK:EMS */, _resource.getURL()), RB
                            .getStringResource("DAVTree.confirmation.txt"), JOptionPane.DEFAULT_OPTION,
                            JOptionPane.INFORMATION_MESSAGE, null, options, options[0]);
                } else selval = 1;
                switch (selval) {
                case 1:
                    doAll = true;
                case 0:
                    _resource.delete();
                    System.out.println(Message.format(RB.getResources(), "DAVTree.delstatus.fmt.txt"/* I18nOK:EMS */,
                            _resource.getURL(), new Integer(_resource.getStatusCode())));
                    if (_resource.getStatusCode() == HttpStatus.SC_NO_CONTENT || _resource.getStatusCode() == HttpStatus.SC_OK)
                            dtModel.removeNodeFromParent(node);
                    break;
                case 2:
                    continue;
                case 3:
                    jumpOut = true;
                    break;
                default:
                }
            } catch (DAVException de) {
                System.out.println(de.getMessage());
                de.printStackTrace();
            } catch (RemoteException re) {
                System.out.println("RemoteException: " + re.getMessage());
                re.printStackTrace();
            }
        }
    }

    /**
     * Add a new resource - display the add resource dialog.
     * 
     * @param e
     *            The action event
     */
    public void miAdd_Action(ActionEvent e) {
        DAVTreeNode node = (DAVTreeNode) jTree.getLastSelectedPathComponent();
        if (node == null) return;
        try {
            DAVResource _resource = getDAVResource(node.fullName);
            if (_resource.isCollection()) {
                int selval = JOptionPane.showConfirmDialog(this, Message.format(RB.getResources(),
                        "DAVTree.addcheck.fmt.txt"/* I18nOK:EMS */, _resource.getURL()), RB
                        .getStringResource("DAVTree.confirmation.txt"), JOptionPane.YES_NO_OPTION,
                        JOptionPane.INFORMATION_MESSAGE);
                if (selval == JOptionPane.YES_OPTION) {
                    AddDlg add_dlg = new AddDlg(this, true);
                    add_dlg.show();
                    boolean isCollection = add_dlg.resourceType.equals("collection"/* I18nOK:EMS */);
                    String newName = add_dlg.name.getText();
                    String newURL = Utils.addSegment(node.fullName, newName);
                    _resource.setPath( Utils.addSegment(_resource.getPath(), newName ) );
                    if ( isCollection ) _resource.makeCollection();
                    else { 
                        // Content
                        String content = add_dlg.content.getText();
                        if (content.length() == 0) content = "No content"/* I18nOK:EMS */;
                        _resource.setContents(content.getBytes());
                    }
                    // Now, the properties
                    Map setUpdates = add_dlg.getSetUpdates();
                    if (!setUpdates.isEmpty()) {
                        try {
                            Iterator updates = setUpdates.entrySet().iterator();
                            while (updates.hasNext()) {
                                Map.Entry me = (Map.Entry) updates.next();
                                PropName p = new PropName((String) me.getKey());
                                Element el = doc.createElementNS(p.getNS(), p.getName());
                                String propVal = (String) me.getValue();
                                if (!propVal.startsWith("<")) {
                                    Text t = doc.createTextNode(propVal);
                                    el.appendChild(t);
                                    _resource.setProperty(el);
                                } else {
                                    boolean parseSuccessful = true;
                                    Document _doc = null;
                                    try {
                                        _doc = builder
                                                .parse(new ByteArrayInputStream((XMLHEADER + propVal).getBytes())); /* I18nOK:COS */
                                    } catch (SAXException sex) {
                                        System.out.println(RB.getStringResource("DAVTree.invalidXMLprop.txt"));
                                        parseSuccessful = false;
                                    }
                                    if (parseSuccessful) _resource.setProperty(_doc.getDocumentElement());
                                }
                            }
                        } catch (Exception ex) {
                            ex.printStackTrace();
                        }
                    }
                }
            } else {
                JOptionPane.showMessageDialog(this, Message.format(RB.getResources(),
                        "DAVTree.noaddhere.fmt.txt"/* I18nOK:EMS */, _resource.getURL()), RB
                        .getStringResource("DAVTree.addresource.txt"), JOptionPane.ERROR_MESSAGE);
            }
        } catch (DAVException de) {
            System.out.println(de.getMessage());
            de.printStackTrace();
        } catch (RemoteException re) {
            System.out.println("RemoteException: " + re.getMessage());
            re.printStackTrace();
        }
    }

    /**
     * Modify a resource - display the modify resource dialog.
     * 
     * @param e
     *            The action event
     */
    public void miModify_Action(ActionEvent e) {
        DAVTreeNode node = (DAVTreeNode) jTree.getLastSelectedPathComponent();
        if (node == null) return;
        int selval = JOptionPane.showConfirmDialog(this, Message.format(RB.getResources(),
                "DAVTree.modcheck.fmt.txt"/* I18nOK:EMS */, node.fullName), RB
                .getStringResource("DAVTree.confirmation.txt"), JOptionPane.YES_NO_OPTION,
                JOptionPane.INFORMATION_MESSAGE);
        if (selval == JOptionPane.YES_OPTION) {
            ModDlg moddlg = new ModDlg(this, node.DAVprops, true);
            moddlg.show();
            Map setUpdates = moddlg.getSetUpdates();
            Vector delUpdates = moddlg.getDelUpdates();
            if (!setUpdates.isEmpty() || !delUpdates.isEmpty()) {
                try {
                    DAVResource _resource = getDAVResource(node.fullName);
                    Iterator updates = setUpdates.entrySet().iterator();
                    while (updates.hasNext()) {
                        Map.Entry me = (Map.Entry) updates.next();
                        PropName p = new PropName((String) me.getKey());
                        Element el = doc.createElementNS(p.getNS(), p.getName());
                        String propVal = (String) me.getValue();
                        if (!propVal.startsWith("<")) {
                            Text t = doc.createTextNode(propVal);
                            el.appendChild(t);
                            _resource.setProperty(el);
                        } else {
                            boolean parseSuccessful = true;
                            Document _doc = null;
                            try {
                                _doc = builder.parse(new ByteArrayInputStream((XMLHEADER + propVal).getBytes())); /* I18nOK:COS */
                            } catch (SAXException sex) {
                                System.out.println(RB.getStringResource("DAVTree.invalidXMLprop.txt"));
                                parseSuccessful = false;
                            }
                            if (parseSuccessful) _resource.setProperty(_doc.getDocumentElement());
                        }
                    }
                    for (int i = 0; i < delUpdates.size(); i++) {
                        PropName p = new PropName((String) delUpdates.get(i));
                        Element el = doc.createElementNS(p.getNS(), p.getName());
                        _resource.removeProperty(el);
                    }
                } catch (Exception ex) {
                    ex.printStackTrace();
                }
            }
        }
    }
    // Inner class that handles tree expansion events
    protected class TreeExpansionHandler implements TreeExpansionListener {

        public void treeExpanded(TreeExpansionEvent evt) {
            TreePath path = evt.getPath();
            JTree tree = (JTree) evt.getSource();
            DAVTreeNode node = (DAVTreeNode) path.getLastPathComponent();
            if (node.populateCollections(DAVTree.this, true)) {
                ((DefaultTreeModel) tree.getModel()).nodeStructureChanged(node);
            }
        }

        public void treeCollapsed(TreeExpansionEvent evt) {
            // Nothing to do
        }
    }
    public class HexDisplayDlg extends JDialog {

      private static final long serialVersionUID = 3616732694617536056L;

      public HexDisplayDlg(Frame owner, String title, byte[] message) {
            super(owner, title, true);
            int DIALOG_WIDTH = 500;
            JTextArea txt;
            Font font = new Font("Monospaced", Font.PLAIN, 12);
            if (message != null) {
                txt = new JTextArea(Utils.bytesToHex(message));
            } else {
                txt = new JTextArea(RB.getStringResource("DAVTree.nocontent.txt"));
            }
            txt.setFont(font);
            JScrollPane txtpane = new JScrollPane(txt);
            //panel.add(txt);
            getContentPane().add(txtpane);
            setSize(500, 600);
            setLocation((screenWidth - DIALOG_WIDTH) / 2, getLocation().y);
            txt.setCaretPosition(0);
            txt.setEditable(false);
        }
    }
    public class OpenDlg extends JDialog {

      private static final long serialVersionUID = 3257572810405524280L;
      private JButton okbutton;

        public OpenDlg(Frame owner, String title, String message) {
            super(owner, title, true);
            Point topLeft = owner.getLocation();
            // setSize(FRAME_WIDTH-50, 75);
            setLocation(topLeft.x + 20, topLeft.y + 50);
            okbutton = new JButton(RB.getStringResource("DAVTree.ok.txt"/* I18nOK:EMS */));
            getContentPane().setLayout(new BorderLayout());
            getContentPane().add(hCombo, "Center"/* I18nOK:EMS */);
            getContentPane().add(okbutton, "South"/* I18nOK:EMS */);
            getRootPane().setDefaultButton(okbutton);
            okbutton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    String newUrl = (String) hCombo.getSelectedItem();
                    try {
                        new URL(newUrl);
                    } catch (MalformedURLException ex) {
                        status.setText(Message.format(RB.getResources(), "DAVTree.badurl.fmt.txt"/* I18nOK:EMS */,
                                newUrl, ex.getMessage()));
                        return;
                    }
                    hCombo.add(newUrl);
                    urlLoc = newUrl;
                    dispose();
                }
            });
            pack();
        }
    }

    public class HistoryComboBox extends JComboBox {

      private static final long serialVersionUID = 3616726084629114935L;
      public static final int MAX_MEM_LEN = 10;

        public HistoryComboBox() {
            super();
            setEditable(true);
            setFont(DIALOG_FONT);
            setMinimumSize(new Dimension(500, 10));
        }

        public void add(String item) {
            removeItem(item);
            insertItemAt(item, 0);
            setSelectedItem(item);
            if (getItemCount() > MAX_MEM_LEN) removeItemAt(getItemCount() - 1);
        }

        public void load(String fName) {
            BufferedReader fRdr = null;
            try {
                if (getItemCount() > 0) removeAllItems();
                File f = new File(fName);
                if (!f.exists()) return;
                fRdr = new BufferedReader(new FileReader(fName));
                String urlEntry;
                while ((urlEntry = fRdr.readLine()) != null) {
                    addItem(urlEntry);
                }
                fRdr.close();
            } catch (IOException e) {
                // Ignore this possibility
            }
        }

        public void save(String fName) {
            try {
                BufferedWriter fWtr = new BufferedWriter(new FileWriter(fName));
                for (int i = 0; i < getItemCount(); i++) {
                    fWtr.write((String) getItemAt(i));
                    fWtr.newLine();
                }
                fWtr.close();
            } catch (Exception e) {
                e.printStackTrace();
                System.err.println(Message.format(RB.getResources(), "DAVResource.serialerr.fmt.txt", e.toString()));
            }
        }
    }

    public class CredentialsDlg extends JDialog {

      private static final long serialVersionUID = 3904960871745466423L;
      private JTextField userid = new JTextField(20);
        private JPasswordField password = new JPasswordField(20);
        private JLabel usrLabel = new JLabel(RB.getStringResource("DAVTree.user.txt"/* I18nOK:EMS */));
        private JLabel pwdLabel = new JLabel(RB.getStringResource("DAVTree.pw.txt"/* I18nOK:EMS */));
        private JButton okButton = new JButton(RB.getStringResource("DAVTree.ok.txt"/* I18nOK:EMS */));
        private JButton cancelButton = new JButton(RB.getStringResource("DAVTree.cancel.txt"/* I18nOK:EMS */));

        public CredentialsDlg(Frame owner, boolean modal) {
            super(owner, modal);
            setTitle(RB.getStringResource("DAVTree.crendentials.title.txt"));
            // setSize(FRAME_WIDTH-200, 100);
            Point topLeft = owner.getLocation();
            setLocation(topLeft.x + 20, topLeft.y + 50);
            //			JPanel topPanel = new JPanel();
            //			JPanel botPanel = new JPanel();
            getContentPane().setLayout(new BorderLayout());
            JPanel fieldsPanel = new JPanel();
            GridBagLayout gbl = new GridBagLayout();
            fieldsPanel.setLayout(gbl);
            GridBagConstraints gbc = new GridBagConstraints();
            gbc.insets = new Insets(3,3,3,3);
            gbc.fill = GridBagConstraints.HORIZONTAL;
            gbc.weightx = 0.0;
            gbc.anchor = GridBagConstraints.WEST;
            gbc.gridwidth = GridBagConstraints.RELATIVE;
            gbl.setConstraints(usrLabel, gbc);
            //usrLabel.setSize( 50, 21 );
            fieldsPanel.add(usrLabel);
            gbc.gridwidth = GridBagConstraints.REMAINDER;
            gbc.weightx = 1.0;
            gbl.setConstraints(userid, gbc);
            //userid.setSize( 80, 21 );
            fieldsPanel.add(userid);
            gbc.gridwidth = GridBagConstraints.RELATIVE;
            gbc.weightx = 0.0;
            gbl.setConstraints(pwdLabel, gbc);
            //pwdLabel.setSize( 50, 21 );
            fieldsPanel.add(pwdLabel);
            gbc.gridwidth = GridBagConstraints.REMAINDER;
            gbc.weightx = 1.0;
            gbl.setConstraints(password, gbc);
            //password.setSize( 80, 21 );
            fieldsPanel.add(password);
            getContentPane().add(fieldsPanel, "Center"/* I18nOK:EMS */);
            JPanel buttonsPanel = new JPanel();
            buttonsPanel.add(okButton);
            buttonsPanel.add(cancelButton);
            getContentPane().add(buttonsPanel, "South"/* I18nOK:EMS */);
            getRootPane().setDefaultButton(okButton);
            okButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    _userid = userid.getText();
                    _password = new String(password.getPassword());
                    dispose();
                }
            });
            cancelButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
            this.addWindowListener(new WindowAdapter() {

                public void windowOpened(WindowEvent evt) {
                    okButton.requestFocus();
                }
            });
        }
    }

    public class ModDlg extends JDialog {

      private static final long serialVersionUID = 3689065140692005687L;
      private JButton okButton = new JButton(RB.getStringResource("DAVTree.ok.txt"/* I18nOK:EMS */));
        private JButton cancelButton = new JButton(RB.getStringResource("DAVTree.cancel.txt"/* I18nOK:EMS */));
        PropertyPanel pPanel;
        Map origNV = new HashMap();

        public ModDlg(Frame owner, TreeMap propsMap, boolean modal) {
            super(owner, modal);
            Iterator items = propsMap.entrySet().iterator();
            while (items.hasNext()) {
                Map.Entry me = (Map.Entry) items.next();
                Element element = (Element) me.getValue();
                String aname = element.getLocalName();
                String ns = element.getNamespaceURI();
                // If simple text value, extract text
                String avalue = null;
                if (element.hasChildNodes()) {
                    Node n = element.getFirstChild();
                    if (n.getNodeType() == Node.TEXT_NODE && n == element.getLastChild()) {
                        avalue = n.getNodeValue();
                    }
                }
                if (avalue == null) avalue = XMLUtil.convertNodeToString(element, true);
                avalue = avalue.replace('\r', ' ');
                avalue = avalue.replace('\n', ' ');
                if (ns == null) {
                    origNV.put(aname, avalue);
                } else {
                    origNV.put("{" + ns + "}" + aname, avalue);
                }
            }
            JPanel buttonsPanel = new JPanel();
            pPanel = new PropertyPanel(origNV);
            buttonsPanel.setLayout(new FlowLayout());
            buttonsPanel.add(okButton);
            buttonsPanel.add(cancelButton);
            getContentPane().setLayout(new BorderLayout());
            getContentPane().add(pPanel, "Center"/* I18nOK:EMS */);
            getContentPane().add(buttonsPanel, "South"/* I18nOK:EMS */);
            okButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
            cancelButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
            this.addWindowListener(new WindowAdapter() {

                public void windowOpened(WindowEvent evt) {
                    okButton.requestFocus();
                }
            });
            pack();
            int centredX = owner.getX() + (owner.getWidth() - getWidth()) / 2;
            setLocation(centredX, owner.getY() + 50);
        }

        public Map getSetUpdates() {
            return pPanel.getSetUpdates();
        }

        public Vector getDelUpdates() {
            return pPanel.getDelUpdates();
        }
    }

    public class AddDlg extends JDialog {

      private static final long serialVersionUID = 3256719593694049846L;
      private JButton okButton = new JButton(RB.getStringResource("DAVTree.ok.txt"/* I18nOK:EMS */));
        private JButton cancelButton = new JButton(RB.getStringResource("DAVTree.cancel.txt"/* I18nOK:EMS */));
        String resourceType = "collection";
        Map origNV = new HashMap();
        PropertyPanel pPanel;
        JTextField name = new JTextField(20);
        JTextArea content = new JTextArea();
        ButtonGroup rescollRadio = new ButtonGroup();
        JRadioButton resButton = new JRadioButton(RB.getStringResource("DAVTree.resource.txt"));
        JRadioButton collButton = new JRadioButton(RB.getStringResource("DAVTree.collection.txt"));
        JPanel hdrPanel;

        public AddDlg(Frame owner, boolean modal) {
            super(owner, modal);
            resButton.setActionCommand("resource"/* I18nOK:EMS */);
            collButton.setActionCommand("collection"/* I18nOK:EMS */);
            collButton.setSelected(true);
            rescollRadio.add(resButton);
            rescollRadio.add(collButton);
            hdrPanel = new JPanel();
            JPanel radioPanel = new JPanel();
            hdrPanel.setLayout(new BorderLayout());
            hdrPanel.add(name, "Center"/* I18nOK:EMS */);
            radioPanel.setLayout(new GridLayout(2, 1));
            radioPanel.add(resButton);
            radioPanel.add(collButton);
            // Register a listener for the radio buttons.
            RadioListener myListener = new RadioListener();
            resButton.addActionListener(myListener);
            collButton.addActionListener(myListener);
            hdrPanel.add(radioPanel, "East"/* I18nOK:EMS */);
            hdrPanel.add(content, "South"/* I18nOK:EMS */);
            JPanel buttonsPanel = new JPanel();
            pPanel = new PropertyPanel(origNV);
            buttonsPanel.setLayout(new FlowLayout());
            buttonsPanel.add(okButton);
            buttonsPanel.add(cancelButton);
            getContentPane().setLayout(new BorderLayout());
            getContentPane().add(hdrPanel, "North"/* I18nOK:EMS */);
            getContentPane().add(pPanel, "Center"/* I18nOK:EMS */);
            getContentPane().add(buttonsPanel, "South"/* I18nOK:EMS */);
            okButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
            cancelButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    dispose();
                }
            });
            this.addWindowListener(new WindowAdapter() {

                public void windowOpened(WindowEvent evt) {
                    okButton.requestFocus();
                }
            });
            pack();
            int centredX = owner.getX() + (owner.getWidth() - getWidth()) / 2;
            setLocation(centredX, owner.getY() + 50);
        }

        public Map getSetUpdates() {
            return pPanel.getSetUpdates();
        }
        class RadioListener implements ActionListener {

            public void actionPerformed(ActionEvent e) {
                if (e.getSource() == resButton) {
                    content.setEnabled(true);
                    resourceType = "resource";
                }
            }
        }
    }
    
    public class PropertyPanel extends JPanel {

      private static final long serialVersionUID = 3256441421597979188L;
      JScrollPane propPane;
        JPanel propPanel;
        GridBagLayout gbl;
        Map _propertyMap;
        Vector labels = new Vector(25);
        Vector textfields = new Vector(25);
        private JButton newpropButton = new JButton(RB.getStringResource("DAVTree.newprop.txt"/* I18nOK:EMS */));

        public PropertyPanel(Map propertyMap) {
            _propertyMap = propertyMap;
            propPanel = new JPanel();
            propPane = new JScrollPane(propPanel, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
                    ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
            propPane.setSize(100, 100);
            gbl = new GridBagLayout();
            propPanel.setLayout(gbl);
            setLayout(new BorderLayout());
            add(newpropButton, "North"/* I18nOK:EMS */);
            add(propPane, "Center"/* I18nOK:EMS */);
            Iterator pItems = _propertyMap.entrySet().iterator();
            while (pItems.hasNext()) {
                Map.Entry me = (Map.Entry) pItems.next();
                addProperty((String) me.getKey(), (String) me.getValue(), false);
            }
            newpropButton.addActionListener(new ActionListener() {

                public void actionPerformed(ActionEvent e) {
                    addProperty("", "", true);
                    propPanel.doLayout();
                    propPane.doLayout();
                    if (getParent() != null) getParent().doLayout();
                }
            });
        }

        public Map getSetUpdates() {
            Map setUpdates = new HashMap();
            for (int i = 0; i < labels.size(); i++) {
                String label = ((JTextField) labels.get(i)).getText();
                String text = ((JTextField) textfields.get(i)).getText();
                if (!_propertyMap.containsKey(label) || !text.equals(_propertyMap.get(label))) {
                    // new or updated property
                    if (text.length() > 0) {
                        setUpdates.put(label, text);
                    }
                }
            }
            return setUpdates;
        }

        public Vector getDelUpdates() {
            Vector delUpdates = new Vector(5);
            for (int i = 0; i < labels.size(); i++) {
                String label = ((JTextField) labels.get(i)).getText();
                String text = ((JTextField) textfields.get(i)).getText();
                if (text.length() == 0) {
                    // delete attribute
                    delUpdates.add(label);
                }
            }
            return delUpdates;
        }

        public void addProperty(String propName, String propVal, boolean nameEditable) {
            JTextField value = new JTextField(propVal, 30);
            JTextField name = new JTextField(propName, 20);
            name.setEditable(nameEditable);
            // if ( ns != null ) name.setToolTipText( ns );
            GridBagConstraints gbc = new GridBagConstraints();
            gbc.fill = GridBagConstraints.HORIZONTAL;
            gbc.weightx = 0.0;
            gbc.anchor = GridBagConstraints.WEST;
            gbc.gridwidth = GridBagConstraints.RELATIVE;
            name.setSize(50, 21);
            propPanel.add(name, gbc);
            gbc.gridwidth = GridBagConstraints.REMAINDER;
            gbc.weightx = 1.0;
            value.setSize(80, 21);
            propPanel.add(value, gbc);
            labels.add(name);
            textfields.add(value);
            //if ( doLayout ) {
            //propPanel.doLayout();
            //propPane.doLayout();
            //if ( !value.isShowing() )
            //    propPane.getVerticalScrollBar().setValue( value.getLocation() );
            //value.requestFocus();
            //}
        }
    }
    public class PropName {

        String ns;
        String name;

        public PropName(String pname) {
            int p2 = pname.indexOf('}');
            if (p2 > 0) {
                name = pname.substring(p2 + 1);
                ns = pname.substring(1, p2);
            } else {
                name = pname;
                ns = "";
            }
        }

        public String getName() {
            return name;
        }

        public String getNS() {
            return ns;
        }
    }

    private void copySubTree(File dir, DAVResource target) {
        try {
            String subdirPath = target.getPath();
            // MKCOL for the subdirectory - keep a copy of the path which will
            // be used to
            // reset the DAV resource target path, as we process each of the
            // files/dirs
            // in the directory.
            target.makeCollection();
            File[] ff = dir.listFiles();
            for (int i = 0; i < ff.length; i++) {
                String newPath = Utils.addSegment(subdirPath, ff[i].getName());
                target.setPath(newPath);
                if (ff[i].isDirectory()) {
                    copySubTree(ff[i], target);
                } else {
                    try {
                        target.setContents(new FileInputStream(ff[i]));
                    } catch (FileNotFoundException fnf) {
                        // Won't happen, system gave us the list of files
                    }
                }
            }
        } catch (DAVException e) {
            // problem copying the subtree
            e.printStackTrace();
        } catch (RemoteException e) {
            // problem copying the subtree
            e.printStackTrace();
        }
    }
    /*
     * Drag and drop tree
     */
    private class DNDTree extends JTree implements DropTargetListener, DragSourceListener, DragGestureListener {

      private static final long serialVersionUID = 3689916149890430517L;
      protected DragSource m_dragSource = null;
        protected DropTarget m_dropTarget = null;
        protected boolean m_drag, m_drop;

        public DNDTree() {
            Init(true, true);
        }

        public DNDTree(boolean drag, boolean drop) {
            Init(drag, drop);
        }

        public DNDTree(TreeModel model, boolean drag, boolean drop) {
            super(model);
            Init(drag, drop);
        }

        private void Init(boolean drag, boolean drop) {
            m_drag = drag;
            m_drop = drop;
            if (m_drag) {
                m_dragSource = new DragSource();
                m_dragSource.createDefaultDragGestureRecognizer(this, DnDConstants.ACTION_COPY_OR_MOVE, this);
            }
            m_dropTarget = new DropTarget(this, this);
        }

        public void dragEnter(DropTargetDragEvent event) {
            if (DAVTree.traceEnabled)
                    System.out.println("DROP dragEnter(" + event.toString() + "):" + this.toString());
            if (m_drop) {
                event.acceptDrag(event.getDropAction());
            } else {
                event.rejectDrag();
            }
        }

        public void dragExit(DropTargetEvent event) {
            if (DAVTree.traceEnabled) System.out.println("DROP dragExit(" + event.toString() + "):" + this.toString());
        }

        public void dragOver(DropTargetDragEvent event) {
            if (DAVTree.traceEnabled) System.out.println("DROP dragOver(" + event.toString() + "):" + this.toString());
            int x = event.getLocation().x;
            int y = event.getLocation().y;
            TreePath path = getPathForLocation(x, y);
            if (path != null) {
                DAVTreeNode xx = (DAVTreeNode) path.getLastPathComponent();
                if (xx.isCollection) {
                    if (DAVTree.traceEnabled)
                            System.out.println("DROP dragover collection path=" + path + " - " + event.getDropAction());
                    event.acceptDrag(event.getDropAction());
                } else {
                    if (DAVTree.traceEnabled) System.out.println("DROP dragover resource path=" + path);
                    event.rejectDrag();
                }
            }
        }

        public void drop(DropTargetDropEvent event) {
            if (DAVTree.traceEnabled) System.out.println("DROPPED (" + event.toString() + ")");
            if ((event.getSourceActions() & DnDConstants.ACTION_COPY_OR_MOVE) != 0) event.acceptDrop(event
                    .getDropAction());
            else {
                event.rejectDrop();
                return;
            }
            Transferable transferable = event.getTransferable();
            DataFlavor[] flavors = event.getCurrentDataFlavors();
            for (int i = 0; i < flavors.length; i++) {
                DataFlavor dataFlavor = flavors[i];
                try {
                    if (dataFlavor.equals(DataFlavor.javaFileListFlavor)) {
                        int x = event.getLocation().x;
                        int y = event.getLocation().y;
                        TreePath tp = getPathForLocation(x, y);
                        if (tp != null) {
                            DAVTreeNode node = (DAVTreeNode) tp.getLastPathComponent();
                            java.util.List fileList = (java.util.List) transferable.getTransferData(dataFlavor);
                            for (int j = 0; j < fileList.size(); j++) {
                                File f = (File) fileList.get(j);
                                String newUrl = Utils.addSegment(node.fullName, f.getName());
                                DAVResource r = getDAVResource(newUrl);
                                if (!f.isDirectory()) {
                                    r.setContents(new FileInputStream(f));
                                } else {
                                    copySubTree(f, r);
                                }
                            }
                            node.populated = false;
                            node.removeAllChildren();
                            if (node.populateCollections(DAVTree.this, true)) {
                                ((DefaultTreeModel) jTree.getModel()).nodeStructureChanged(node);
                            }
                        }
                        event.dropComplete(true);
                        return;
                    } else if ("DAVTree.Resource".equals(dataFlavor.getHumanPresentableName())) {
                        DAVTreeNode source = (DAVTreeNode)transferable.getTransferData(dataFlavor);
                        String s = source.fullName;
                        // String s = (String) transferable.getTransferData(dataFlavor);
                        int x = event.getLocation().x;
                        int y = event.getLocation().y;
                        TreePath tp = getPathForLocation(x, y);
                        if (tp != null) {
                            DAVTreeNode node = (DAVTreeNode) tp.getLastPathComponent();
                            URL _url;
                            try {
                                _url = new URL(node.fullName);
                            } catch (MalformedURLException e) {
                                _url = null;
                            }
                            if (_url != null) {
                                DAVResource r = getDAVResource(s);
                                if (s.endsWith("/")) s = s.substring(0, s.length() - 1);
                                if ((event.getDropAction() & DnDConstants.ACTION_MOVE) != 0) {
                                    r.move(Utils.addSegment(_url.getPath(), s.substring(s.lastIndexOf("/"))));
                                    if ( r.SUCCEEDED() ) source.removeFromParent();
                                } else if ((event.getDropAction() & DnDConstants.ACTION_COPY) != 0) {
                                    r.copy(Utils.addSegment(_url.getPath(), s.substring(s.lastIndexOf("/"))));
                                }
                            }
                        }
                        event.dropComplete(true);
                        return;
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    event.dropComplete(false);
                    return;
                }
            }
            event.dropComplete(false);
        }

        protected boolean itemCanBeDroppedOn(Object ob) {
            if (DAVTree.traceEnabled)
                    System.out.println("itemCanBeDroppedOn(" + ob.toString() + "):" + this.toString());
            return true;
        }

        public void dropActionChanged(DropTargetDragEvent event) {
            if (DAVTree.traceEnabled)
                    System.out.println("DROP dropActionChanged(" + event.toString() + "):" + this.toString());
        }

        public void dragGestureRecognized(DragGestureEvent event) {
            TreePath treepath = getSelectionPath();
            if (treepath != null) {
                Object o = treepath.getLastPathComponent();
                WebDAVTransferable wt = new WebDAVTransferable((DAVTreeNode) o);
                m_dragSource.startDrag(event, null, wt, this);
            }
            if (DAVTree.traceEnabled)
                    System.out.println("dragGestureRecognized(" + event.toString() + "):" + this.toString());
        }

        public void dragDropEnd(DragSourceDropEvent event) {

            if (DAVTree.traceEnabled) System.out.println("Drag Drop End");
            dndFile = null;
            dndString = null;
            inDragDrop = false;
            if ( event.getDropSuccess()) { 
                if ( DAVTree.traceEnabled) System.out.println("Succeeded "+event.getDropAction()+" event");
            }
            if (DAVTree.traceEnabled)
                    System.out.println("DRAG dragDropEnd(" + event.toString() + "):" + this.toString());
            inDragDrop = false;
        }

        public void dragEnter(DragSourceDragEvent event) {
            if (DAVTree.traceEnabled)
                    System.out.println("DRAG dragEnter(" + event.toString() + "):" + this.toString());
        }

        public void dragExit(DragSourceEvent event) {
            if (DAVTree.traceEnabled) System.out.println("DRAG dragExit(" + event.toString() + "):" + this.toString());
        }

        public void dragOver(DragSourceDragEvent event) {
            if (DAVTree.traceEnabled) System.out.println("DRAG dragOver(" + event.toString() + "):" + this.toString());
        }

        public void dropActionChanged(DragSourceDragEvent event) {
            if (DAVTree.traceEnabled)
                    System.out.println("DRAG dropActionChanged(" + event.toString() + "):" + this.toString());
        }
    }

    private class WebDAVTransferable implements Transferable, ClipboardOwner {
        
        private DataFlavor resourceFlavor = new DataFlavor(DAVTreeNode.class, "DAVTree.Resource");
        private DataFlavor contentsFlavor = new DataFlavor(new String().getClass(), "DAVTree.Contents");
        private DataFlavor[] flavors = { resourceFlavor, DataFlavor.javaFileListFlavor };
        private List flavorList = Arrays.asList(flavors);
        transient Object m_obj;

        public WebDAVTransferable(DAVTreeNode node) {
            m_obj = node;
        }

        //
        public synchronized DataFlavor[] getTransferDataFlavors() {
            return flavors;
        }

        //
        public boolean isDataFlavorSupported(DataFlavor df) {
            boolean isOK = false;
            if (DAVTree.traceEnabled) System.out.println("isDataFlavorSupported " + df.toString());
            isOK = flavorList.contains(df);
            return isOK;
        }

        public void lostOwnership(Clipboard c, Transferable t) {
            m_obj = null;
        }

        public synchronized Object getTransferData(DataFlavor df) throws UnsupportedFlavorException, IOException {
            if ( df.equals(resourceFlavor) ) return m_obj;
//            else if ( df.equals(contentsFlavor) ) {
//                if ( dndString == null ) {
//	                try {
//	                    DAVResource r = getDAVResource( ((DAVTreeNode)m_obj).fullName );
//	                    System.out.println("---- getContentsAsString ----");
//	                    dndString = r.getContentsAsString();
//	                    return dndString;
//	                } catch ( DAVException e ) {
//	                    return null;
//	                }
//                } else return dndString;
//            } 
            else if ( df.equals(DataFlavor.javaFileListFlavor)) {
                if ( dndFile == null ) {
	                byte[] buffer = new byte[8192];
	                dndFile = new File( tmpdir+File.separator+((DAVTreeNode)m_obj).resName );
	                dndFile.deleteOnExit();
	                try {
		                OutputStream os = new FileOutputStream(dndFile);
	                    DAVResource r = getDAVResource( ((DAVTreeNode)m_obj).fullName );
	                    InputStream is = r.getContentsInputStream();
	                    int len;
	                    while ( (len=is.read(buffer, 0, buffer.length)) != -1 ) {
	                        os.write( buffer, 0, len );
	                    }
	                    os.close();
	                    is.close();
	                } catch ( DAVException e ) {
	                    return null;
	                }
	                inDragDrop = true;
                }
                List l = new java.util.ArrayList();
                l.add(dndFile);
                return l;
            }
            else return null;
        }
    }
    
    private String stripTrailingSlashes(String s) {
        StringBuffer buffer = new StringBuffer(s);
        int len = buffer.length();
        // strip trailing slashes
        for (int i = len-1; i >= 0; i--) {
            if (buffer.charAt(i) != '/') {
                break;
            }
            buffer.setLength(i);
        }
        return buffer.toString();
    } 

}
