/* $Id: Splash.java,v 1.1.2.1.14.1 2005/10/11 15:58:43 domelz Exp $ */
//Copyright (c) 2001-2004 SAS Institute Inc., Cary, NC 27513
//All Rights Reserved.
package com.sas.services.webdav.tools;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JWindow;
import javax.swing.SwingUtilities;

/**
 * Displays a splash screen
 * @author Rob Owen
 * @version 1.0 12-Dec-2001
 */
public class Splash extends JWindow
{
   private static final long serialVersionUID = 3257004362860738614L;

   public Splash(Frame f, int waitTime)
	{
		super(f);
		JLabel l = new JLabel( new ImageIcon(this.getClass().getClassLoader().getResource("com/sas/services/webdav/tools/splash.gif")));
		getContentPane().add(l,BorderLayout.CENTER);
		pack();
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension lDim = l.getPreferredSize();
		setLocation(screenSize.width/2 - lDim.width/2, screenSize.height/2 - lDim.height/2);
		addMouseListener(
			new MouseAdapter()
			{
				public void mousePressed(MouseEvent me)
				{
					setVisible(false);
					dispose();
				}
			}
		);

		final int pause = waitTime;
		final Runnable executioner =
			new Runnable()
			{
				public void run()
				{
					setVisible(false);
					dispose();
				}
			};

		Runnable splasher =
			new Runnable()
			{
				public void run()
				{
					try
					{
						Thread.sleep(pause);
						SwingUtilities.invokeAndWait(executioner);
					}
					catch (Exception e)
					{
						e.printStackTrace();
					}
				}
			};

		setVisible(true);
		Thread splashThread = new Thread(splasher);
		splashThread.start();
	}
}

