/*
 * Copyright (c) 2006 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm;

import java.rmi.AccessException;
import java.rmi.NotBoundException;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Properties;

import com.sas.solutions.brm.errors.BRMInternalError;
import com.sas.solutions.brm.errors.BRMUserError;
import com.sas.solutions.brm.logging.RemoteLoggingInterface;
import com.sas.solutions.brm.util.ConfigFile;

public interface BRMAgentInterface extends Remote
{
    public static final String RMICLIENT_REGISTRY_NAME = "BRMAgent";

    public void setup(String machineName, ConfigFile controlConfig)
        throws BRMUserError, BRMInternalError, RemoteException;

    public void setRemoteLogger(RemoteLoggingInterface remoteLogger)
        throws RemoteException;

    public void updateControlConfig(ConfigFile controlConfig)
        throws RemoteException;

    public void backupConfigFiles()
        throws BRMUserError, BRMInternalError, RemoteException;

    public void setComponent(String component)
        throws BRMUserError, BRMInternalError, RemoteException;

    public Collection discoverSASLibraryDirs()
        throws BRMUserError, BRMInternalError, RemoteException;
    
    public boolean backup() 
        throws BRMUserError, BRMInternalError, RemoteException;

    public boolean restore() 
        throws BRMUserError, BRMInternalError, RemoteException;

    public boolean startServices() 
        throws BRMUserError, BRMInternalError, RemoteException;

    public boolean stopServices() 
        throws BRMUserError, BRMInternalError, RemoteException;

    public boolean executeCommand(String command)
        throws BRMUserError, BRMInternalError, RemoteException;

    public void teardown()
        throws AccessException, RemoteException, NotBoundException;
}
