/*
 * Copyright (c) 2007 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm;

import java.rmi.RemoteException;

import com.sas.solutions.brm.errors.BRMInternalError;
import com.sas.solutions.brm.errors.BRMUserError;

public class BackupTaskRunner extends TaskRunner
{
    private boolean configFilesBackedUp;

    public BackupTaskRunner(BRMController controller, String host)
    {
        super(controller, host);
        this.configFilesBackedUp = false;
    }

    public boolean runCurrentTask()
        throws BRMUserError, BRMInternalError, RemoteException
    {
        if (!this.configFilesBackedUp)
        {
            getAgent().backupConfigFiles();
            this.configFilesBackedUp = true;
        }
        return getAgent().backup();
    }
}
