/*
 * Copyright (c) 2006 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm;

import java.io.Serializable;

public interface Constants extends Serializable
{
    /*
     * This block of strings represents the various components 
     * that BRM should know about at COMPILE time.
     * 
     */
    public static final String WEBAPP_COMPONENT = "webapp_component";
    public static final String METADATA_COMPONENT = "metadata_component";
    public static final String MYSQL_COMPONENT = "mysql_component";
    public static final String STORED_PROCESS_COMPONENT = "stored_process_component";
    public static final String WORKSPACE_COMPONENT = "workspace_component";
    public static final String OLAP_COMPONENT = "olap_component";
    public static final String REMOTE_SERVICES_COMPONENT = "remote_services_component";
    public static final String OBJECT_SPAWNER_COMPONENT = "object_spawner_component";
    public static final String ODCS_COMPONENT = "odcs_component";
    public static final String CONNECT_COMPONENT ="connect_component";
    public static final String WEBDAV_COMPONENT ="webdav_component";

    // These keys are for communicating between the controller and the agent
    public static final String STORED_PROC_DIRS_PROP = "StoredProcDirs";
    
    /*
     * This block of Integers are the flags that should
     * be passed to the checkpoint system for 
     * synchronization.
     */
    public static final Integer SERVICES_STOPPED_PRE = new Integer(10);
    public static final Integer SERVICES_STOPPED_POST = new Integer(20);
    public static final Integer BR_FINISHED = new Integer(30);
    public static final Integer BR_COMMITTED = new Integer(40);
    public static final Integer SERVICES_RESTARTED = new Integer(50);

    // Install property files
    public static final String SOLTNSDATA = "soltnsdata.properties";
    public static final String SOLTNSMID = "soltnsmid.properties";
    public static final String MYSQLDBS = "mysqldbs.properties";
    public static final String[] INSTALL_PROPERTIES_FILES = new String[]{
        SOLTNSDATA, SOLTNSMID, MYSQLDBS,
        };

    // Useful install property names
    public static final String SAS_EXE_DIR = "SAS_EXE_DIR";

    // Config files
    public static final String AGENT_CONFIG_FILE = "brmagent.properties";
    public static final String AGENT_COMMAND_FILE = "agentAnt.xml";
    public static final String AGENT_CUSTOM_FILE = "customAnt.xml";
    public static final String LOG4J_CONFIG_FILE = "log4j.properties";
    public static final String BRM_CONFIG_FILE = "cmdLine.properties";
    public static final String MIGRATE_CONFIG_FILE = "migrate.ini";

    public static final String[] CONFIG_FILES_WARNIFNOTTHERE = new String[]{
        AGENT_COMMAND_FILE,
        AGENT_CONFIG_FILE,
        LOG4J_CONFIG_FILE,
        };

    public static final String[] CONFIG_FILES = new String[]{
        BRM_CONFIG_FILE, 
        MIGRATE_CONFIG_FILE,
        AGENT_CUSTOM_FILE,
        };

    // Constants related to the agent
    public static final String AGENT_PORT_PROPERTY = "BRM.agent.port";
    public static final int AGENT_DEFAULT_PORT = 2206;
}
