package com.sas.solutions.brm;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.Properties;

import org.apache.tools.ant.DefaultLogger;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.ProjectHelper;
import org.apache.tools.ant.Target;
import org.apache.tools.ant.Task;
import org.apache.tools.ant.helper.ProjectHelperImpl;
import org.apache.tools.ant.taskdefs.Tar;

public class antTester {
    public static void main(String args[]) {
        antTester tester = new antTester();
        tester.test();
        
    }
    
    public void test() {
        Project ant = new Project();
        ant.init();
        ProjectHelper helper = new ProjectHelperImpl();
        helper.parse(ant, new File("../../config/agentAnt.xml"));
        ant.setProperty("output","Hello, World!");
        DefaultLogger log = new DefaultLogger();
        log.setErrorPrintStream(System.err);
        log.setOutputPrintStream(System.out);
        log.setMessageOutputLevel(Project.MSG_INFO);
        ant.addBuildListener(log);
        
        Properties agentProps = new Properties();
        try{
            agentProps.load(new FileInputStream("../../config/agentAnt.properties"));
            for(Iterator i = agentProps.keySet().iterator();i.hasNext();){
                String key = (String)i.next();
                ant.setProperty(key,agentProps.getProperty(key.toString()));
            }
        }catch(IOException e) {
            System.out.println("couldn't find properties file");
        }
        
        ant.executeTarget("echo");
        
        Target backupMetadata = (Target)ant.getTargets().get("backupMetadata");
        Task[] mdTasks = backupMetadata.getTasks();
        for(int i = 0;i<mdTasks.length;i++){
            if(mdTasks[i].getTaskName().equals("tar")){
                Tar task = (Tar)mdTasks[i];
                task.setIncludes(ant.getProperty("metadataIncludes"));
                task.setExcludes(ant.getProperty("metadataExcludes"));
                System.out.println("exclude doubly set: "+i);
            }
        }
        
        ant.executeTarget("backupMetadata");

    
    }
}
