/*
 * Created on Apr 13, 2006
 * Copyright (c) 2006 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.errors;

/**
 * Exception thrown by the Backup, Restore, and Migrate tool when an
 * error occurs that prevents further processing, that is due to programmer
 * error or unknown cause. The error message is not localized, since it is
 * intended more for the devloper than for the end user.
 * 
 * @author davhan
 *
 */
public class BRMInternalError extends BRMError
{

    public BRMInternalError()
    {
        super();
    }

    public BRMInternalError(String message)
    {
        super(message);
    }

    public BRMInternalError(Throwable cause)
    {
        super(cause);
    }

    public BRMInternalError(String message, Throwable cause)
    {
        super(message, cause);
    }

}
