/*
 * Created on Apr 13, 2006
 * Copyright (c) 2006 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.errors;

/**
 * Exception thrown by the Backup, Restore, and Migrate tool when an error
 * occurs that is not a programming error, and has a known cause that the
 * user can understand and possibly fix. (This is not meant to imply that it
 * is the user's "fault", but that the error message may be of use to the 
 * user.)
 * 
 * @author davhan
 *
 */
public class BRMUserError extends BRMError
{

    public BRMUserError()
    {
        super();
    }

    public BRMUserError(String message)
    {
        super(message);
    }

    public BRMUserError(Throwable cause)
    {
        super(cause);
    }

    public BRMUserError(String message, Throwable cause)
    {
        super(message, cause);
    }

}
