/*
 * Created on Feb 13, 2007
 * Copyright (c) 2007 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.logging;

import org.apache.log4j.BasicConfigurator;
import org.apache.log4j.Logger;

/**
  * Configure log4j logging.
  *
  * See "The Complete Log4j Manual" by Ceki Glc, for log4j version 1.2.9,
  * December 2004 revision, p. 83.
  */
public class LogConfigurator
{
    private LogConfigurator()
    {
        // Un-callable constructor
    }

    /**
      * Configure log4j. Sets up log4j via BasicConfigurator (which sets up
      * a basic console appender on the root logger) only if some config
      * file hasn't already set up at least the root logger.
      */
    public static void configure()
    {
        Logger root = Logger.getRootLogger();
        boolean rootIsConfigured = root.getAllAppenders().hasMoreElements();
        if (!rootIsConfigured)
        {
            BasicConfigurator.configure();
        }
    }
}
