/*
 * Created on Feb 16, 2007
 * Copyright (c) 2007 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.logging;

import java.rmi.RemoteException;

/**
  * Test remote logging.
  * Paradoxically, this class is an rmi server. It is only a client
  * with respect to logging.
  * @see com.sas.solutions.brm.logging.RemoteLoggingServer
  * @see com.sas.solutions.brm.logging.RemoteAppender;
  */
public class RemoteLoggingTester
    extends java.rmi.server.UnicastRemoteObject
    implements RemoteLoggingTesterInterface
{
    public RemoteLoggingTester() throws RemoteException
    {
        System.out.println("Constructing RemoteLoggingTester");
    }

    public void setRemoteLogger(RemoteLoggingInterface remoteLogger)
        throws RemoteException
    {
        System.out.println("RemoteLoggingTester.setRemoteLogger: " +
                remoteLogger);
        RemoteLoggingClient.setLogServer(remoteLogger);
    }

    public void teardown()
        throws RemoteException
    {
        System.out.println("RemoteLoggingTester.teardown");
        java.rmi.registry.Registry registry = 
            java.rmi.registry.LocateRegistry.getRegistry(PORT);
        try
        {
            registry.unbind(NAME);
        }
        catch (Exception e)
        {
            throw new RemoteException("Error unbinding " + NAME, e);
        }
        java.rmi.server.UnicastRemoteObject.unexportObject(this, true);
    }

    public void run() throws Exception
    {
        System.out.println("RemoteLoggingTester.run");
        java.rmi.registry.Registry registry = 
            java.rmi.registry.LocateRegistry.createRegistry(PORT);
        registry.bind(NAME, this);
    }
}
