/*
 * Created on Jun 8, 2006
 * Copyright (c) 2006 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.migrate;

/**
 * This class represents the search parameters to find a set of Metadata
 * objects in OMR and the name of the action to take (method to call)
 * for each of those objects.
 * 
 * @author davhan
 *
 */
public class MigrateAction
{
    private String typeName;
    private String repositoryName;
    private String searchParam;
    private String methodName;
    private String methodParam;

    public MigrateAction(String typeName, String repositoryName, 
            String searchParam, String methodName)
    {
        this(typeName, repositoryName, searchParam, methodName, null);
    }

    public MigrateAction(String typeName, String repositoryName, 
            String searchParam, String methodName, String methodParam)
    {
        this.typeName = typeName;
        this.repositoryName = repositoryName;
        this.searchParam = searchParam;
        this.methodName = methodName;
        this.methodParam = methodParam;
    }

    public String getTypeName()
    {
        return this.typeName;
    }
    
    public String getRepositoryName()
    {
        return this.repositoryName;
    }
    
    public String getSearchParam()
    {
        return this.searchParam;
    }
    
    public String getMethodName()
    {
        return this.methodName;
    }
    
    public String getMethodParam()
    {
        return this.methodParam;
    }
}
