/*
 * Created on Jun 12, 2006
 * Copyright (c) 2006 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.omr;

import java.io.StringReader;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.helpers.DefaultHandler;

public class BaseOMRXMLHandler extends DefaultHandler
{

    public BaseOMRXMLHandler()
    {
        super();
    }

    public static void parseXML(BaseOMRXMLHandler handler, String inputXML) 
    {
       try 
       {
          //create a new sax parser
          SAXParserFactory parserFactory = SAXParserFactory.newInstance();
          parserFactory.setNamespaceAware(false);
          parserFactory.setValidating(true);        
          SAXParser parser = parserFactory.newSAXParser();
                      
          // parse the input xml file
          if ((inputXML != null) && (inputXML.length() > 0))
          {
             StringReader sr = new StringReader(inputXML);          
             org.xml.sax.InputSource is = new org.xml.sax.InputSource(sr);
             parser.parse(is, handler);
             parser = null;
          }
       }     
       catch (Exception e)
       { 
          //if the parsing fails, then the process should be aborted
          throw new Error(e);
       } 
    }

}
