/*
 * Created on Jun 6, 2006
 * Copyright (c) 2006 by SAS Institute Inc., Cary, NC 27513
 */
package com.sas.solutions.brm.omr;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


public class OMRGraphExtractor
{
    private OMRConnection omr;

    public OMRGraphExtractor(OMRConnection omr)
    {
        this.omr = omr;
    }
    
    public void extractLogins()
    {
        String typeName = "Login";
        this.omr.setFoundationRepository();
        List logins = this.omr.doOMRQuery(typeName, "");
        System.out.println("Login list: " + logins);
        
        Map objMap = new HashMap();
        this.omr.getObjectsFollowingAssociations(logins, objMap);
        System.out.println("Number of objects associated with all Logins: " + objMap.size());
        
        Map typeCountMap = new HashMap();
        String objTypeName;
        for (Iterator objIter=objMap.values().iterator(); objIter.hasNext(); )
        {
            GenericMetadataObject objInfo = (GenericMetadataObject)objIter.next();
            objTypeName = objInfo.getTypeName();
            Integer typeCount = (Integer)typeCountMap.get(objTypeName);
            if (typeCount == null)
                typeCountMap.put(objTypeName, new Integer(1));
            else
                typeCountMap.put(objTypeName, 
                        new Integer(typeCount.intValue() + 1));
        }
        Object[] typeNames = typeCountMap.keySet().toArray();
        Arrays.sort(typeNames);
        for (int i=0; i<typeNames.length; ++i)
        {
            objTypeName = (String)typeNames[i];
            System.out.println(objTypeName + ": " + 
                    typeCountMap.get(objTypeName));
        }
    }

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        OMRConnection omr = new OMRConnection(
                "sestest1", "8561", "sasadm", "AdminAdmin1"
                //"ngl2xp1.emea.sas.com", "8561", "ngladm", "Ng1123"
                );
        omr.connect();
        System.out.println("Connected to OMR on " + omr.getHost());
        OMRGraphExtractor oge = new OMRGraphExtractor(omr);
        oge.extractLogins();
        omr.close();
    }

}
