/* $Id: ColumnAlignmentInterface.java,v 1.2.2.1.4.1 2004/12/03 21:14:47 sasbcl Exp $ */
package com.sas.table;


/**
 * An interface that adds the ability to determine display preferences of data from the model. 
 * @author sabrey
 * @version 1.0
 * @history
 * <dl>
 * <dt>3/05/04 <dd>Created.
 * </dl>
 * * @author sabrey
 */

public interface ColumnAlignmentInterface
{
    /**
	 * Returns the preferred alignment for the data in the specified column. Returns SwingConstants.LEFT or
	 * SwingConstants.RIGHT depending on if the data should be left or right aligned.  
	 * @param columnIndex the column index in the model that the column alignment is to be returned for
	 * @return preferred alignment for the data in the specified column
	 */
    public int getColumnAlignment(int columnIndex);

}
