package com.sas.table;

/**
 * An interface that adds the ability for a model to return whther it contains formatted
 * or unforammated data. Viewers or other models may need to know whether a model already
 * contains formatted or not.
 *
 * @author Drew Anderson
 * @version 1.0
 * @history
 * <dl>
 * <dt>7/03 <dd>Created.
 * </dl>
 */
public interface FormattedDataReturnedInterface
{
//	/**
//	 * Sets whether the model contains formatted or unformatted data.is using formatted data or just the raw data.
//	 * A call to getFormattedVaueAt(int, int) should ignore this variable and
//	 * always return the formatted data when possible. The getColumnClass(int) method
//	 * should pay attention to this value and return the column class based on whether
//	 * formatted or unformatted data is being used.
//	 * @param useFormattedData whether to use formatted data by default versus raw data
//	 * @see #isFormattedDataUsed()
//	 */
//	/**
//	* Determines whether the generated result set contains formatted or unformatted data. The default is true, which means formatted data is returned in the result set.
//	* @param formattedDataReturned determines whether whether the generated result set contains formatted or unformatted data
//	*/
//	public void setFormattedDataReturned(boolean useFormattedData);

	/**
	 * Returns whether the model contains formatted or unformatted data.
	 * @return true if the model contains formatted data, false otherwise
	 */
	public boolean isFormattedDataReturned();
}