package com.sas.table;

/**
 * Interface for implementing sorting which returns only distinct values
 * for the sorted columns.
 * @author sasccf Chad Ferguson
 * @date 29OCT2002
 */

public interface SortDistinctValuesInterface extends SortableInterface
{
	/**
	 * Returns a boolean indicating whether the sorted columns should return only
	 * distinct values. In other words, remove duplicate values for the sorted
	 * columns.
	 * @return A boolean indicating the sorted columns should return only distinct
	 * values
	 */
	public boolean isDistinctValues();

	/**
	 * Sets whether the sorted columns should return only distinct values.
	 * @param distinct true if only distinct values should be return for the
	 * sorted columns
	 */
	public void setDistinctValues(boolean distinct);
}