package com.sas.table;

/**
 * Conveys exceptions that occur when invoking the methods defined by the
 * SortableInterface.
 * Since an implementation of these interfaces can generate various types of 
 * exceptions, a SortException is used to trap all these variants.
 * @author sasccf Chad Ferguson
 * @version 3.0
 * @date 20Apr2001
 * @see com.sas.table.SortableInterface
 */

public class SortException extends Exception
{
	/** default value for error code */
	public static final int ERROR_CODE_DEFAULT = 0;
	private int errorCode;

	public SortException ()
	{
		super ();
	}

	public SortException (String s)
	{
		super (s);
	}

	public SortException (Exception ex)
	{
		super (ex.toString());
	}

	/** Returns the error code set by the application throwing the exception.
	 * @return the error code
	 */
	public int getErrorCode()
	{
		return errorCode;
	}

	/** This method sets the error code to any int.
	 * @param errorCode	One of the class constants for error code
	 */
	public void setErrorCode (int errorCode)
	{
		this.errorCode = errorCode;
	}
}