package com.sas.util;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 * @author SDKNBJ
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ConditionEvaluation
		implements com.sas.util.ConditionEvaluationInterface {

	private Map _conditions = new HashMap();

	private Map _columnMap = new HashMap();

	private Map _columnIndexMap = new HashMap();


	public int getColumnType(Object identifier) {
		return ((Integer) _columnMap.get(identifier)).intValue();
	}


	public int getColumnIndex(Object identifier) {
		return ((Integer) _columnIndexMap.get(identifier)).intValue();
	}


	public Object evaluateConditions(Object identifier, Object[] rowValues) {
		Object formatting = null;

		List conditionList = getConditions(identifier);

		if (conditionList != null) {
			for (Iterator iterator = conditionList.iterator(); iterator.hasNext() && formatting == null;) {
				AbstractCondition condition = (AbstractCondition) iterator.next();

				formatting = condition.evaluate(this, rowValues);
			}
		}

		return formatting;
	}

	private void addColumn(Object identifier, int type) {
		_columnMap.put(identifier, new Integer(type));
		_columnIndexMap.put(identifier, new Integer(_columnIndexMap.size()));
	}


	public List getConditions(Object identifier) {
		return (List) _conditions.get(identifier);
	}


	public void setColumnMetadata(Object[][] columnMetadata) {
		for (int i = 0; i < columnMetadata.length; i++) {
			addColumn((String) columnMetadata[i][0], ((Integer) columnMetadata[i][1]).intValue());
		}
	}


	public void setConditions(Object identifier, List conditions) {
		_conditions.put(identifier, conditions);
	}
}
