package com.sas.util;

import java.util.List;

/**
 * @author SDKNBJ
 * 
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public interface ConditionEvaluationInterface {
	/**
	 * Method setConditions.
	 * Sets the conditions for the specified column
	 * @param columnID the column to set the conditions for.
	 * @param conditions the list of conditions to set.
	 */
	public void setConditions(Object identifier, List conditions);

	/**
	 * Method getConditions.
	 * Gets the conditions for the specified column
	 * @param columnID the column to get the conditions for.
	 * @return List the list of conditions for the specified column
	 */
	public List getConditions(Object identifier);
	
	/**
	 * Method evaluateConditions.
	 * Evaluates the conditions that has been set for the specified column,
	 * @param columnID the column to evaluate conditions for
	 * @param rowValues the values in column order for the current row.
	 * @return Object the formatting that should be applied. If no conditions
	 * where true, null is returned.
	 */
	public Object evaluateConditions(Object identifier, Object[] rowValues);
	
	/**
	 * Method getColumnType.
	 * Returns the column type for the specified column
	 * @param columnID the column to get the type for.
	 * @return int the type (Character or Numeric) of the specified column.
	 */
	public int getColumnType(Object identifier);

	/**
	 * Method getColumnIndex.
	 * Returns the 0-based column index of the specified column
	 * @param columnID the column to get the index for.
	 * @return int the column index for the specified column.
	 */
	public int getColumnIndex(Object identifier);

	/**
	 * Method setColumnMetadata.
	 * @param columnMetadata
	 */
	public void setColumnMetadata(Object[][] columnMetadata);
}
