// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.util;
import com.sas.util.PredicateInterface;

/**
 * <code>Countable</code> is used for objects which have a countable number of things.
 * For example, collections are countable; their <code>{@link #count()}</code> is the number
 * of items in the collection.
 *
 * @author <A HREF="http://www.unx.sas.com/~sasdjb/Home.html">David J. Biesack</A>
 * @version 1.0
 */

public interface Countable
{

  /**
   * Returns the number of items in the object
   * @return the number of items in the object
   */
  public int count();

}
