// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.util;

import java.util.Enumeration;

/**
 * A basic interface for enumerable objects. Enumerable objects
 * are objects, such as collection, which provide {@link java.util.Enumeration} objects for visiting
 * the contents.
 * @author <A HREF="http://www.unx.sas.com/~sasdjb/Home.html">David J. Biesack</A>
 * @version 1.0
 */

public interface Enumerable
{

  /**
   * Return an enumeration of objects.
   * @return an enumeration of objects. If the <code>Enumerable</code> does not support
   *         enumerations, the <code>getItems()</code> method returns <code>null</code>
   *         (An empty <code>Enumerable</code> still returns a non-<code>null</code>
   *         <code>Enumeration</code>, but the first call to
   *         {@link java.util.Enumeration#hasMoreElements() <code>hasMoreElements()</code>}
   *         returns <code>false</code>).
   */
  public Enumeration getItems();

}
