/* $Id: ExceptionCodeInterface.java,v 1.1.2.1.4.1 2004/12/03 21:14:48 sasbcl Exp $ */
package com.sas.util;

import java.util.Locale;

/**
* An interface for exceptions that need an error code and a notion of "authoritativeness"
* for logging purposes.  Exception classes that want to log errors using error codes will implement this
* interface.
*/
public interface ExceptionCodeInterface
{
	/* return the error code for the exception */
	public String getGenericExceptionCode();

	/* return the authoritative flag for the exception */
	public boolean isAuthoritative();
	
	/* return a localized message for this exception */
	/* may return super getLocalizedMessage */
	public String getLocalizedMessage(Locale locale);
}
