// Copyright (C) 2000 by SAS Institute Inc., Cary, NC 27513

package com.sas.util;

/**
 * Guid is a class for generating Globally Unique Identifiers, or GUIDs.
 * Guid is a Singleton class; there is only one instance
 * @author sasdjb <A HREF="http://sww.sas.com/~sasdjb/Home.html">David J. Biesack</A>
 * @version 1.0
 * @deprecated This class will be replaced by a new service in the BI Platform.
 */
public class Guid
{
  private static int count = (int) (System.currentTimeMillis() & 0xffff);
  private static Guid defaultInstance = new Guid();
  // private constructor enforces Singleton
  private Guid()
  {
  }

  /**
   * Make a guid.
   */
  public static String makeGuid()
  {
    return defaultInstance.next();
  }

  /**
   * Get the Singleton Guid instance.
   * @return the Singleton instance
   */
  public static Guid getInstance()
  {
    return defaultInstance;
  }

  /**
   * Return the next GUID
   */
  public String next()
  {
    long time = System.currentTimeMillis();
    time <<= 16;
    time += ((count++) & 0xfff);
    return Long.toHexString(time);
  }
}
