// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.util;

/**
 * An interface which allows the caller to
 * test objects for some boolean condition.
 * @author Ernest Pasour
 * @version 1.0
 */

public interface PredicateInterface
{
  /**
   * Determine whether an object satisfies a condition.
   * The object implementing PredicateInterface
   * will implement this boolean condition in this
   * method.
   * @param o the object which should be tested.
   * @return <code>true</code> if the object satisfies the
   *		condition, <code>false</code> otherwise.
   */
  boolean predicate(Object o);
}
