package com.sas.util;

import java.util.List;

/**
 *  Defines a provider of a set of roles and a set of items that can 
 *  be assigned to those roles.  For example, a data table could be defined
 *  as a provider with two roles, "column" and "slicer", and a 
 *  set of variables.
 * 
 */
public interface RoleProviderInterface 
   {

   /**
    *  Returns the available roles.
    *  @return an array of roles
    */
   public RoleInterface[] getRoles ();

   /**
    *  Returns all the items that can be assigned to the roles.
    *  @return an array of items
    */
   public List getRoleItems ();

   }