/* Copyright (c) 2002 by SAS Institute Inc., Cary, NC 27513 */
package com.sas.util;

/**
 * Interface for constants for indicating a sort direction.
 * 
 * @author Drew Anderson
 * @date 10/28/2002
 */

public interface SortDirectionInterface
{
	/**
	 * Value indicating an item is sorted in ascending order (default)
	 */
	public static final int ASCENDING = 0;

	/**
	 * Value indicating an item is sorted in descending order 
	 */
	public static final int DESCENDING = 1;

	/**
	 * Value indicating a column is not sorted at the current time
	 */
	public static final int NOT_SORTED = 2;
}