// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.util;

/**
 * An interface which defines some constant time intervals, in millisecnds.
 *
 * @author sasdjb <A HREF="http://www.unx.sas.com/~sasdjb/Home.html">David J. Biesack</A>
 * @version 1.0
 */

public interface TimeIntervals
{

  /** milliseconds per second */
  public static long ONE_SECOND = 1000;

  /** milliseconds per minute */
  public static long ONE_MINUTE = 60 * ONE_SECOND;

  /** milliseconds per hour */
  public static long ONE_HOUR   = 60 * ONE_MINUTE;

  /** milliseconds per day */
  public static long ONE_DAY    = 24 * ONE_HOUR;

  /** milliseconds per week */
  public static long ONE_WEEK   =  7 * ONE_DAY;
  
}
