// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;

/**
 * The BooleanToByteTransform converts an instance of Booleanto a Byte.
 * If the value of the Boolean is true, the value of the Byte is set to one.
 * Otherwise, the value of the Byte returned is set to zero.
 */
public class BooleanToByteTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 256899152294673648L;

	public static final BooleanToByteTransform defaultInstance = new BooleanToByteTransform();

	public Object transform( Object value )
	{
		Boolean bool = (Boolean) value;
		if ( bool.booleanValue() == true )
		{
			return new Byte( (byte) 1 );
		}
		return new Byte( (byte) 0 );
	}

	public Class getInputClass()
	{
		return Boolean.class;
	}

	public Class getOutputClass()
	{
		return Byte.class;
	}
}
