// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;

/**
 * The BooleanToDoubleTransform converts an instance of Booleanto a Double.
 * If the value of the Boolean is true, the value of the Double is set to one.
 * Otherwise, the value of the Double returned is set to zero.
 */
public class BooleanToDoubleTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 256899152294673648L;

	public static final BooleanToDoubleTransform defaultInstance = new BooleanToDoubleTransform();

	public Object transform( Object value )
	{
		Boolean bool = (Boolean) value;
		if ( bool.booleanValue() == true )
		{
			return new Double( (double) 1 );
		}
		return new Double( (double) 0 );
	}

	public Class getInputClass()
	{
		return Boolean.class;
	}

	public Class getOutputClass()
	{
		return Double.class;
	}
}
