// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;

/**
 * The BooleanToDoubleTransform converts an instance of Booleanto a Float.
 * If the value of the Boolean is true, the value of the Float is set to one.
 * Otherwise, the value of the Float returned is set to zero.
 */
public class BooleanToFloatTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 256899152294673648L;

	public static final BooleanToFloatTransform defaultInstance = new BooleanToFloatTransform();

	public Object transform( Object value )
	{
		Boolean bool = (Boolean) value;
		if ( bool.booleanValue() == true )
		{
			return new Float( (float) 1 );
		}
		return new Float( (float) 0 );
	}

	public Class getInputClass()
	{
		return Boolean.class;
	}

	public Class getOutputClass()
	{
		return Float.class;
	}
}
