// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;

/**
 * The BooleanToDoubleTransform converts an instance of Booleanto an Integer.
 * If the value of the Boolean is true, the value of the Integer is set to one.
 * Otherwise, the value of the Integer returned is set to zero.
 */
public class BooleanToIntegerTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 256899152294673648L;

	public static final BooleanToIntegerTransform defaultInstance = new BooleanToIntegerTransform();

	public Object transform( Object value )
	{
		Boolean bool = (Boolean) value;
		if ( bool.booleanValue() == true )
		{
			return new Integer( 1 );
		}
		return new Integer( 0 );
	}

	public Class getInputClass()
	{
		return Boolean.class;
	}

	public Class getOutputClass()
	{
		return Integer.class;
	}
}
