// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;

/**
 * The BooleanToDoubleTransform converts an instance of Booleanto a Long.
 * If the value of the Boolean is true, the value of the Long is set to one.
 * Otherwise, the value of the Long returned is set to zero.
 */
public class BooleanToShortTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 256899152294673648L;

	public static final BooleanToShortTransform defaultInstance = new BooleanToShortTransform();

	public Object transform( Object value )
	{
		Boolean bool = (Boolean) value;
		if ( bool.booleanValue() == true )
		{
			return new Short( (short) 1 );
		}
		return new Short( (short) 0 );
	}

	public Class getInputClass()
	{
		return Boolean.class;
	}

	public Class getOutputClass()
	{
		return Short.class;
	}
}
