// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

/**
 * An identify transform. This is a transform which simply
 * implements the identity functions f(x) = x.
 * @author sasdjb <A HREF="http://www.unx.sas.com/~sasdjb/Home.html">David J. Biesack</A>
 * @version 1.0
 */

/*
 * @support sasdjb
 * @history
 * <dl>
 * <dt>sasdjb 27Feb97<dd>Created
 * </dl>
 */

package com.sas.util.transforms;
import com.sas.util.transforms.TransformInputOutputInterface;

public class IdentityTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 2323707621776221179L;

  /**
   * a static identity transform. There is no real need to create multiple
   * instances of this object, since they are all alike. Use this
   * instance instead of creating new instances.
   */
  public final static IdentityTransform identityTransform = new IdentityTransform();

  /**
   * The identity transform; this is a no op function that returns
   * the input parameter
   * @param obj any object
   * @return the same object
   */
  public Object transform(Object obj)
  {
    return obj;
  }

	public Class getInputClass()
	{
		return Object.class;
	}

	public Class getOutputClass()
	{
		return Object.class;
	}
}
