// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;

import com.sas.MissingValues;

/**
 * The MissingValuesToStringTransform converts a MissingValues object to a String.  The input.toString() value
 *  will be returned if the input value cannot be equated to a String representation of a com.sas.MissingValues object.
 */
public class MissingValuesToStringTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = -4873329888576249830L;

	public static final MissingValuesToStringTransform defaultInstance = 
		new MissingValuesToStringTransform();

	public Object transform( Object input )
	{
		if (input == null)
		   return input;

		if (input.equals(MissingValues.Dot))
			return ".";
		else if (input.equals(MissingValues._))
			return "._";
		else if (input.equals(MissingValues._BLANK_))
			return "_BLANK_";

		else if (input.equals(MissingValues.A))
			return ".A";
		else if (input.equals(MissingValues.B))
			return ".B";
		else if (input.equals(MissingValues.C))
			return ".C";
		else if (input.equals(MissingValues.D))
			return ".D";
		else if (input.equals(MissingValues.E))
			return ".E";
		else if (input.equals(MissingValues.F))
			return ".F";
		else if (input.equals(MissingValues.G))
			return ".G";
		else if (input.equals(MissingValues.H))
			return ".H";
		else if (input.equals(MissingValues.I))
			return ".I";
		else if (input.equals(MissingValues.J))
			return ".J";
		else if (input.equals(MissingValues.K))
			return ".K";
		else if (input.equals(MissingValues.L))
			return ".L";
		else if (input.equals(MissingValues.M))
			return ".M";
		else if (input.equals(MissingValues.N))
			return ".N";
		else if (input.equals(MissingValues.O))
			return ".O";
		else if (input.equals(MissingValues.P))
			return ".P";
		else if (input.equals(MissingValues.Q))
			return ".Q";
		else if (input.equals(MissingValues.R))
			return ".R";
		else if (input.equals(MissingValues.S))
			return ".S";
		else if (input.equals(MissingValues.T))
			return ".T";
		else if (input.equals(MissingValues.U))
			return ".U";
		else if (input.equals(MissingValues.V))
			return ".V";
		else if (input.equals(MissingValues.W))
			return ".W";
		else if (input.equals(MissingValues.X))
			return ".X";
		else if (input.equals(MissingValues.Y))
			return ".Y";
		else if (input.equals(MissingValues.Z))
			return ".Z";

		else
			return input.toString();

	}

	public Class getInputClass()
	{
		return com.sas.MissingValues.class;
	}

	public Class getOutputClass()
	{
		return String.class;
	}
}
