// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;

/**
 * The NumberToBooleanTransform converts an instance of a Number subclass (ie. Integer,
 * Long, Double, etc...) to a Boolean.  If the value of the Number is zero, FALSE is 
 * returned.  Otherwise, TRUE is returned.
 */
public class NumberToBooleanTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 256899152294673648L;

	public static final NumberToBooleanTransform defaultInstance = new NumberToBooleanTransform();

	public Object transform( Object value )
	{
		Number numValue = (Number) value;
		if ( numValue.intValue() == 0 )
		{
			return Boolean.FALSE;
		}
		return Boolean.TRUE;
	}

	public Class getInputClass()
	{
		return Number.class;
	}

	public Class getOutputClass()
	{
		return Boolean.class;
	}
}
