// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.util.transforms;

import java.io.IOException;
import java.io.ObjectInputStream;

public class RoundNumberTransform
	implements TransformInterface
{
	protected int decimalPlaces;
	transient protected double multiplier;

	public RoundNumberTransform()
	{
		this( 2 );
	}

	public RoundNumberTransform( int places )
	{
		setDigitsAfterDecimal( places );
	}

	public int getDigitsAfterDecimal()
	{
		return decimalPlaces;
	}

	public void setDigitsAfterDecimal( int places )
	{
		decimalPlaces = places;
		multiplier = Math.pow( 10, (double)decimalPlaces );
	}

	private void readObject(ObjectInputStream s) throws ClassNotFoundException, IOException 
	{
		s.defaultReadObject();
		multiplier = Math.pow( 10, (double)decimalPlaces );
	}

	public Object transform( Object o )
	{
		if ( o instanceof Number )
		{
			double numberValue = ((Number)o).doubleValue();
			numberValue = numberValue * multiplier;
			numberValue = (double)Math.round( numberValue );
			numberValue = numberValue/multiplier;

			return new Double( numberValue );
		}
		else
			return null;
	}
}
