// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;


public class StringArrayToVectorTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 7824439463353713215L;

	public static final StringArrayToVectorTransform defaultInstance = new StringArrayToVectorTransform();
	
	public Object transform( Object input )
	{
		String[] strings = (String[]) input;
		java.util.Vector vector = new java.util.Vector();
		for ( int i = 0; i < strings.length; i++)
		{
			vector.addElement(strings[i]);
		} // for
		
		return vector;
	}

	public Class getInputClass()
	{
		return String[].class;
	}

	public Class getOutputClass()
	{
		return java.util.Vector.class;
	}
}
