// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;

import com.sas.MissingValues;

/**
 * The StringToMissingValuesTransform converts a String to a MissingValues object.  The input value
 * to the transform will be returned if the input value cannot be equated to a com.sas.MissingValues object.
 */
public class StringToMissingValuesTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = -4873329888576249830L;

	public static final StringToMissingValuesTransform defaultInstance = 
		new StringToMissingValuesTransform();

	public Object transform( Object input )
	{
		if (input == null)
		   return input;

		String trimmedInput = ((String)input).trim();
		if (trimmedInput.length() == 0)
			return trimmedInput;

		if (trimmedInput.equals("."))
			return MissingValues.Dot;
		if (trimmedInput.equals("._"))
			return MissingValues._;
		else if (trimmedInput.equals("_BLANK_")) 
			return MissingValues._BLANK_;
		else if (trimmedInput.equals(".A"))
			return MissingValues.A;
		else if (trimmedInput.equals(".B"))
			return MissingValues.B;
		else if (trimmedInput.equals(".C"))
			return MissingValues.C;
		else if (trimmedInput.equals(".D"))
			return MissingValues.D;
		else if (trimmedInput.equals(".E"))
			return MissingValues.E;
		else if (trimmedInput.equals(".F"))
			return MissingValues.F;
		else if (trimmedInput.equals(".G"))
			return MissingValues.G;
		else if (trimmedInput.equals(".H"))
			return MissingValues.H;
		else if (trimmedInput.equals(".I"))
			return MissingValues.I;
		else if (trimmedInput.equals(".J"))
			return MissingValues.J;
		else if (trimmedInput.equals(".K"))
			return MissingValues.K;
		else if (trimmedInput.equals(".L"))
			return MissingValues.L;
		else if (trimmedInput.equals(".M"))
			return MissingValues.M;
		else if (trimmedInput.equals(".N"))
			return MissingValues.N;
		else if (trimmedInput.equals(".O"))
			return MissingValues.O;
		else if (trimmedInput.equals(".P"))
			return MissingValues.P;
		else if (trimmedInput.equals(".Q"))
			return MissingValues.Q;
		else if (trimmedInput.equals(".R"))
			return MissingValues.R;
		else if (trimmedInput.equals(".S"))
			return MissingValues.S;
		else if (trimmedInput.equals(".T"))
			return MissingValues.T;
		else if (trimmedInput.equals(".U"))
			return MissingValues.U;
		else if (trimmedInput.equals(".V"))
			return MissingValues.V;
		else if (trimmedInput.equals(".W"))
			return MissingValues.W;
		else if (trimmedInput.equals(".X"))
			return MissingValues.X;
		else if (trimmedInput.equals(".Y"))
			return MissingValues.Y;
		else if (trimmedInput.equals(".Z"))
			return MissingValues.Z;
		else
			return trimmedInput;



	}

	public Class getInputClass()
	{
		return String.class;
	}

	public Class getOutputClass()
	{
		return com.sas.MissingValues.class;
	}
}
