// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;


/**
 * Creates a one element array and assigns a string to the one element of the array.
 */
public class StringToOneElementStringArrayTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = -4873329888576249830L;

	public static final StringToOneElementStringArrayTransform defaultInstance = 
		new StringToOneElementStringArrayTransform();

	public Object transform( Object input )
	{
		String array[] = new String[1];
		array[0] = (String)input;
		return array;
	}

	public Class getInputClass()
	{
		return String.class;
	}

	public Class getOutputClass()
	{
		return String[].class;
	}
}
