// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513
package com.sas.util.transforms;

import com.sas.util.transforms.TransformException;

import java.text.ParseException;
import java.text.DateFormat;
import java.util.Locale;

public class StringToSQLDateTransform extends StringToDateTransform
{
	static final long serialVersionUID = -7670709939329023996L;

	public static final StringToSQLDateTransform defaultInstance = new StringToSQLDateTransform();

	/**
	 * 
	 */
	public StringToSQLDateTransform()
	{
		this(Locale.getDefault());
	}

	/**
	 * 
	 * @param locale
	 */
	public StringToSQLDateTransform(Locale locale)
	{
		super(locale);
	}
		
	/**
	 * 
	 */
	public Object transform( Object input ) throws TransformException
	{
		if ( input != null )
		{
			if (dateFormatter == null)
			{
				dateFormatter = DateFormat.getDateInstance(DateFormat.DEFAULT, locale);
			}

			try
			{
				return new java.sql.Date(((java.util.Date)dateFormatter.parse((String)input)).getTime());
			}
			catch (ParseException e)
			{
				TransformException te = new TransformException(e.getMessage());
				te.initCause(e);
				throw te;
			}			
		}

		return nullString;
	}

	public Class getOutputClass()
	{
		return java.sql.Date.class;
	}	
}
