/* Copyright (c) 2001 by SAS Institute Inc., Cary, NC 27513 */
package com.sas.util.transforms;

/**
 * An extension of the TransformInterface which allows the user to know what the 
 * input and output classes for the transform are. This is useful when a transform has
 * been set and the user needs to know the type of objec tthat will be returned from the
 * transform method. 
 * <P>
 * The display transforms in teh TableModelAdapter used on a JTable use this property
 * to help display and use betters editors besides the default JTextField.
 * effect how Objects are displayed in the viewer.
 * @author Drew Anderson
 * @version 3.0
 */

public interface TransformInputOutputInterface extends TransformInterface
{
	/**
	 * The class type that the instance of the TransformInterface needs. This can be a base
	 * class or a specfic class type.
	 * @return the class type the transform needs as input
	 */
	public Class getInputClass();

	/**
	 * The class type that the instance of the TransformInterface will return. This can be a base
	 * class or a specfic class type.
	 * @return the class type the transform returns as a value after the transform method finishes
	 */
	public Class getOutputClass();
}