// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513


package com.sas.util.transforms;


public class VectorToStringArrayTransform implements TransformInputOutputInterface
{
	static final long serialVersionUID = 2518653838763993551L;

	public static final VectorToStringArrayTransform defaultInstance = new VectorToStringArrayTransform();
	
	public Object transform( Object input )
	{
		java.util.Vector vector = (java.util.Vector) input;
		String[] returnValue = new String[ vector.size() ];

		java.util.Enumeration e = vector.elements();
		int i = 0;
		while ( e.hasMoreElements() )
		{
			returnValue[i++] = (String) e.nextElement();
		} // for

		return returnValue;
	}

	public Class getInputClass()
	{
		return java.util.Vector.class;
	}

	public Class getOutputClass()
	{
		return String[].class;
	}
}
