// Copyright (c) 1998 by SAS Institute Inc., Cary, NC 27513

package com.sas.visuals;

import java.awt.Dimension;

/**
 * IconInterface is an interface extending from PainterInterface, 
 * used to paint an area on a component, with a preferredSize for the 
 * area to be painted.
 *
 * @author Brandt Obermeit
 * @see com.sas.visuals.PainterInterface
 **/
public interface IconInterface extends PainterInterface
{
	/**
	* Return the preferredSize of the area to be painted.
	**/
	public Dimension getPreferredSize();
}

